// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDS3DBuffer.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               
// Description:  This file contains the code for the TDS3DBuffer Component 
//
// "TDx_Sound_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDS3DBuffer.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Sound_Library_Defns"
#pragma link "TDx_Sound_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDS3DBuffer*)
{
    new TDS3DBuffer(NULL);
}
// --------------------------------------------------------------------------
namespace Tds3dbuffer
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDS3DBuffer)};
        RegisterComponents("TDx_Sound", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDS3DBuffer::TDS3DBuffer()
// Description: The default constructor for the TDS3DBuffer object.
// --------------------------------------------------------------------------
__fastcall TDS3DBuffer::TDS3DBuffer(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fMode_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDS3DBuffer::~TDS3DBuffer()
// Description: The destructor for the TDS3DBuffer object.
// --------------------------------------------------------------------------
__fastcall TDS3DBuffer::~TDS3DBuffer()
{
if (fMode_Strings!=NULL) delete fMode_Strings;
}
// --------------------------------------------------------------------------
// Property:    ConeOrientation
// Description: The ConeOrientation property defines a D3DVECTOR which 
//              describes the current orientation of the 3D sound cone. 
//              This vector represents the center of the sound cone. 
// --------------------------------------------------------------------------
D3DVECTOR __fastcall TDS3DBuffer::FGetConeOrientation()
{
return fDS3DBUFFER.vConeOrientation;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::FSetConeOrientation( D3DVECTOR pConeOrientation )
{
fDS3DBUFFER.vConeOrientation = pConeOrientation;
}
// --------------------------------------------------------------------------
// Property:    ConeOutsideVolume
// Description: The ConeOutsideVolume property defines, in 100ths of a 
//              decibel, the cone outside volume. 
// --------------------------------------------------------------------------
long __fastcall TDS3DBuffer::FGetConeOutsideVolume()
{
return fDS3DBUFFER.lConeOutsideVolume;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::FSetConeOutsideVolume( long pConeOutsideVolume )
{
fDS3DBUFFER.lConeOutsideVolume = pConeOutsideVolume;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDS3DBuffer method or fget/fset. 
//              eg. DS_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDS3DBuffer::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    InsideConeAngle
// Description: The InsideConeAngle property defines the angle, in degrees, 
//              of the inside sound projection cone. 
// --------------------------------------------------------------------------
dword __fastcall TDS3DBuffer::FGetInsideConeAngle()
{
return fDS3DBUFFER.dwInsideConeAngle;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::FSetInsideConeAngle( dword pInsideConeAngle )
{
fDS3DBUFFER.dwInsideConeAngle = pInsideConeAngle;
}
// --------------------------------------------------------------------------
// Property:    MaxDistance
// Description: The MaxDistance property defines a D3DVALUE indicating, 
//              usually in metres, a sounds maximum distance. 
//              A sound may be turned off when maximum distance is reached by 
//              setting DSBCAPS_MUTE3DATMAXDISTANCE when creating the 3D 
//              sound buffer. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TDS3DBuffer::FGetMaxDistance()
{
return fDS3DBUFFER.flMaxDistance;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::FSetMaxDistance( D3DVALUE pMaxDistance )
{
fDS3DBUFFER.flMaxDistance = pMaxDistance;
}
// --------------------------------------------------------------------------
// Property:    MinDistance
// Description: The MinDistance property defines a D3DVALUE indicating, 
//              usually in metres, a sounds minimum distance. 
//              The default value for this property is 1. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TDS3DBuffer::FGetMinDistance()
{
return fDS3DBUFFER.flMinDistance;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::FSetMinDistance( D3DVALUE pMinDistance )
{
fDS3DBUFFER.flMinDistance = pMinDistance;
}
// --------------------------------------------------------------------------
// Property:    Mode
// Description: The Mode property defines flags indicating the 3D sound 
//              processing mode that is used for the 3D sound buffer. 
//              The described effect applies when the flag is set. 
// Flags:       DS3DMODE_DISABLE -
//                Disable all 3D sound processing. 
//                With no 3D processing, sounds will seem to originate from 
//                the center of the listeners head. 
//              DS3DMODE_HEADRELATIVE -
//                Make all properties, like a sounds position, velocity and 
//                orientation, relative to those of the listener. 
//                The absolute properties of the sound are modified 
//                automatically whenever the listeners parameters change. 
//                This results in the sounds relative parameters remaining 
//                constant. 
//              DS3DMODE_NORMAL -
//                Position and orient the sound source absolutely in world 
//                space. 
//                This is the default processing mode. 
// --------------------------------------------------------------------------
dword __fastcall TDS3DBuffer::FGetMode()
{
return fDS3DBUFFER.dwMode;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::FSetMode( dword pMode )
{
fDS3DBUFFER.dwMode = pMode;
}
// --------------------------------------------------------------------------
// Property:    OutsideConeAngle
// Description: The OutsideConeAngle property defines the angle, in degrees, 
//              of the outside sound projection cone. 
//              This angle must always equal or exceed that of the inside 
//              sound projection cone angle. 
// --------------------------------------------------------------------------
dword __fastcall TDS3DBuffer::FGetOutsideConeAngle()
{
return fDS3DBUFFER.dwOutsideConeAngle;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::FSetOutsideConeAngle( dword pOutsideConeAngle )
{
fDS3DBUFFER.dwOutsideConeAngle = pOutsideConeAngle;
}
// --------------------------------------------------------------------------
// Property:    Position
// Description: The Position property defines a D3DVECTOR which describes the 
//              current position of the 3D sound buffer. 
// --------------------------------------------------------------------------
D3DVECTOR __fastcall TDS3DBuffer::FGetPosition()
{
return fDS3DBUFFER.vPosition;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::FSetPosition( D3DVECTOR pPosition )
{
fDS3DBUFFER.vPosition = pPosition;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDS3DBuffer::FGetSize()
{
return fDS3DBUFFER.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::FSetSize( dword pSize )
{
fDS3DBUFFER.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Velocity
// Description: The Velocity property defines a D3DVECTOR which describes the 
//              current velocity of the 3D sound buffer. 
// --------------------------------------------------------------------------
D3DVECTOR __fastcall TDS3DBuffer::FGetVelocity()
{
return fDS3DBUFFER.vVelocity;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::FSetVelocity( D3DVECTOR pVelocity )
{
fDS3DBUFFER.vVelocity = pVelocity;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDS3DBuffer's internal DS3DBUFFER structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::Clear()
{
fDS3DBUFFER.lConeOutsideVolume = 0;
fErrorValue = DS_OK;
fDS3DBUFFER.dwInsideConeAngle = 0;
fDS3DBUFFER.dwMode = 0;
fDS3DBUFFER.dwOutsideConeAngle = 0;
fDS3DBUFFER.dwSize = sizeof(DS3DBUFFER);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DS3DBUFFER* __fastcall TDS3DBuffer::FGetInternal_DS3DBUFFER_Ptr()
{
return &fDS3DBUFFER;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::FSetInternal_DS3DBUFFER( DS3DBUFFER* pDS3DBUFFER )
{
if (pDS3DBUFFER==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDS3DBuffer::FSetInternal_DS3DBUFFER()", "TDX_ERROR", "The supplied DS3DBUFFER* was NULL" );
    return;
    }

CopyMemory( &fDS3DBUFFER, pDS3DBUFFER, sizeof(DS3DBUFFER) );
Internal_DS3DBUFFER_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::Internal_DS3DBUFFER_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetMode_
// Description: This method returns a TDS3DBuffer_Mode_Set<> of the flags in 
//              the current fDS3DBUFFER.dwMode. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDS3DBuffer_Mode_Set __fastcall TDS3DBuffer::FGetMode_()
{
TDS3DBuffer_Mode_Set TempMode_;
TempMode_.Clear();
if (fDS3DBUFFER.dwMode & DS3DMODE_DISABLE) TempMode_ = TempMode_ << ds3dmode_disable;
if (fDS3DBUFFER.dwMode & DS3DMODE_HEADRELATIVE) TempMode_ = TempMode_ << ds3dmode_headrelative;
if (fDS3DBUFFER.dwMode & DS3DMODE_NORMAL) TempMode_ = TempMode_ << ds3dmode_normal;
return TempMode_;
}
// --------------------------------------------------------------------------
void __fastcall TDS3DBuffer::FSetMode_( TDS3DBuffer_Mode_Set pMode_ )
{
fDS3DBUFFER.dwMode = 0;
if (pMode_.Contains(ds3dmode_disable)) fDS3DBUFFER.dwMode |= DS3DMODE_DISABLE;
if (pMode_.Contains(ds3dmode_headrelative)) fDS3DBUFFER.dwMode |= DS3DMODE_HEADRELATIVE;
if (pMode_.Contains(ds3dmode_normal)) fDS3DBUFFER.dwMode |= DS3DMODE_NORMAL;
}
// --------------------------------------------------------------------------
// Method:      FGetMode_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Mode' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDS3DBuffer::FGetMode_Strings()
{
// if the strings have not been allocated
if (fMode_Strings==NULL)
    {
    // attempt to allocate the strings
    fMode_Strings = new TStringList();
    // if the allocation failed
    if (fMode_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDS3DBuffer::FGetMode_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Mode_Strings" );
        return NULL;
        }
    }
fMode_Strings->Clear();
if (fDS3DBUFFER.dwMode & DS3DMODE_DISABLE) fMode_Strings->Add("DS3DMODE_DISABLE");
if (fDS3DBUFFER.dwMode & DS3DMODE_HEADRELATIVE) fMode_Strings->Add("DS3DMODE_HEADRELATIVE");
if (fDS3DBUFFER.dwMode & DS3DMODE_NORMAL) fMode_Strings->Add("DS3DMODE_NORMAL");
return fMode_Strings;
}
// --------------------------------------------------------------------------
