// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDSBPositionNotify.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               
// Description:  This file contains the code for the TDSBPositionNotify 
//               Component 
//
// "TDx_Sound_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDSBPositionNotify.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Sound_Library_Defns"
#pragma link "TDx_Sound_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDSBPositionNotify*)
{
    new TDSBPositionNotify(NULL);
}
// --------------------------------------------------------------------------
namespace Tdsbpositionnotify
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDSBPositionNotify)};
        RegisterComponents("TDx_Sound", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDSBPositionNotify::TDSBPositionNotify()
// Description: The default constructor for the TDSBPositionNotify object.
// --------------------------------------------------------------------------
__fastcall TDSBPositionNotify::TDSBPositionNotify(TComponent* Owner)
    : TComponent(Owner)
{
fDSBPOSITIONNOTIFY=NULL;
fArraySize=0;
ArraySize=1;
ClearAll();
}
// --------------------------------------------------------------------------
// Destructor:  TDSBPositionNotify::~TDSBPositionNotify()
// Description: The destructor for the TDSBPositionNotify object.
// --------------------------------------------------------------------------
__fastcall TDSBPositionNotify::~TDSBPositionNotify()
{
// destroy internals
if (ArraySize!=0) ArraySize = 0;
}
// --------------------------------------------------------------------------
// Property:    ArraySize
// Description: The ArraySize property contains the number of internal 
//              DSBPOSITIONNOTIFY structures wrapped inside the 
//              TDSBPositionNotify component. 
//              By default the ArraySize is initialized to 1, meaning that 
//              this TDSBPositionNotify component wraps a single 
//              DSBPOSITIONNOTIFY structure. To wrap multiple structures, set 
//              the TDSBPositionNotify::ArraySize to the total number of 
//              internal structures desired. 
// --------------------------------------------------------------------------
dword __fastcall TDSBPositionNotify::FGetArraySize()
{
return fArraySize;
}
// --------------------------------------------------------------------------
void __fastcall TDSBPositionNotify::FSetArraySize( dword pArraySize )
{
// check for size==0
if (pArraySize==0)
    {
    // de-allocate old memory
    delete[] fDSBPOSITIONNOTIFY;
    fDSBPOSITIONNOTIFY = NULL;
    fArraySize = 0;
    return;
    }

// is anything allocated?
if (fArraySize==0)
    {
    // nope. need to allocate memory for pointers to internal structures
    fDSBPOSITIONNOTIFY = new DSBPOSITIONNOTIFY[pArraySize];
    if (fDSBPOSITIONNOTIFY==NULL)
        {
        fArraySize = 0;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDSBPOSITIONNOTIFY::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DSBPOSITIONNOTIFY structure pointers.");
        return;
        }
    // setup defaults
    fArraySize = pArraySize;
    ClearAll();
    }
else
    // already allocated... has the size increased?
    if (pArraySize>fArraySize)
        {
        // allocate space for the new structures
        DSBPOSITIONNOTIFY* temp_DSBPOSITIONNOTIFY = new DSBPOSITIONNOTIFY[pArraySize];
        if (temp_DSBPOSITIONNOTIFY==NULL)
            {
            fErrorValue = TDX_ERROR;
            if (FOnError) FOnError(this, "TDSBPOSITIONNOTIFY::FSetArraySize()", "TDX_ERROR", "Could not allocate extra memory for storing internal DSBPOSITIONNOTIFY structures.");
            return;
            }
        // clear new data areas
        ZeroMemory( &temp_DSBPOSITIONNOTIFY[fArraySize], sizeof(DSBPOSITIONNOTIFY)*(pArraySize-fArraySize) );
        // duplicate existing data
        CopyMemory( &temp_DSBPOSITIONNOTIFY[0], &fDSBPOSITIONNOTIFY[0], sizeof(DSBPOSITIONNOTIFY)*fArraySize);
        // de-allocate old memory
        delete[] fDSBPOSITIONNOTIFY;
        // re-assign the new memory
        fDSBPOSITIONNOTIFY = temp_DSBPOSITIONNOTIFY;
        // store new array size
        fArraySize = pArraySize;
        }
    else
        // already allocated... has the size reduced?
        if (pArraySize<fArraySize)
            {
            // allocate space for the new structures
            DSBPOSITIONNOTIFY* temp_DSBPOSITIONNOTIFY = new DSBPOSITIONNOTIFY[pArraySize];
            if (temp_DSBPOSITIONNOTIFY==NULL)
                {
                fErrorValue = TDX_ERROR;
                if (FOnError) FOnError(this, "TDSBPOSITIONNOTIFY::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DSBPOSITIONNOTIFY structures.");
                return;
                }
            // duplicate existing data
            CopyMemory( &temp_DSBPOSITIONNOTIFY[0], &fDSBPOSITIONNOTIFY[0], sizeof(DSBPOSITIONNOTIFY)*pArraySize);
            // de-allocate the old memory
            delete[] fDSBPOSITIONNOTIFY;
            // re-assign the new memory
            fDSBPOSITIONNOTIFY = temp_DSBPOSITIONNOTIFY;
            // store new array size
            fArraySize = pArraySize;
            }
// else - size is the same.
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDSBPositionNotify method or 
//              fget/fset. eg. DS_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDSBPositionNotify::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDSBPositionNotify::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    EventNotify
// Description: The EventNotify property defines the handle of the Win32 
//              event to be signaled whenever the condition contained in the 
//              TDSBPositionNotify::Offset is achieved. 
// --------------------------------------------------------------------------
HANDLE __fastcall TDSBPositionNotify::FGetEventNotify( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDSBPositionNotify::FGetEventNotify()", "TDX_ERROR", "Internal Array size is 0.");
    return (HANDLE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDSBPositionNotify::FGetEventNotify()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (HANDLE) NULL;
    }

return fDSBPOSITIONNOTIFY[pArrayIndex].hEventNotify;
}
// --------------------------------------------------------------------------
void __fastcall TDSBPositionNotify::FSetEventNotify( dword pArrayIndex, HANDLE pEventNotify )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDSBPositionNotify::FSetEventNotify()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDSBPositionNotify::FSetEventNotify()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDSBPOSITIONNOTIFY[pArrayIndex].hEventNotify = pEventNotify;
}
// --------------------------------------------------------------------------
// Property:    Offset
// Description: The Offset property defines the position of a notification 
//              event trigger. 
//              
//              This value is either an offset, in bytes, from the beginning 
//              of the sound buffer or DSBPN_OFFSETSTOP. 
//              
//              DSBPN_OFFSETSTOP doesnt represent a specific point in the 
//              buffer but triggers a notification event when the buffer 
//              ceases playing or recording. 
// --------------------------------------------------------------------------
dword __fastcall TDSBPositionNotify::FGetOffset( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDSBPositionNotify::FGetOffset()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDSBPositionNotify::FGetOffset()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDSBPOSITIONNOTIFY[pArrayIndex].dwOffset;
}
// --------------------------------------------------------------------------
void __fastcall TDSBPositionNotify::FSetOffset( dword pArrayIndex, dword pOffset )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDSBPositionNotify::FSetOffset()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDSBPositionNotify::FSetOffset()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDSBPOSITIONNOTIFY[pArrayIndex].dwOffset = pOffset;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of a single 
//              internal DSBPOSITIONNOTIFY structure. 
// --------------------------------------------------------------------------
dword __fastcall TDSBPositionNotify::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDSBPositionNotify::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SizeAll
// Description: The SizeAll property contains the size in bytes of all 
//              internal DSBPOSITIONNOTIFY structures. This result is the 
//              same as multiplying TDSBPositionNotify::ArraySize and 
//              TDSBPositionNotify::Size. 
// --------------------------------------------------------------------------
dword __fastcall TDSBPositionNotify::FGetSizeAll()
{
return fArraySize * fSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDSBPositionNotify's internal DSBPOSITIONNOTIFY structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// Params:      pArrayIndex - 
//                The ArrayIndex parameter determines which internal structure 
//                needs to be cleared. Correct values range from 0 to 
//                TDSBPositionNotify::ArraySize-1. 
// --------------------------------------------------------------------------
void __fastcall TDSBPositionNotify::Clear( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDSBPositionNotify::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDSBPositionNotify::Clear()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

ZeroMemory( &fDSBPOSITIONNOTIFY[pArrayIndex], sizeof(DSBPOSITIONNOTIFY) );
}


// --------------------------------------------------------------------------
// Method:      ClearAll()
// Description: The ClearAll() method can be used to clear the contents of 
//              all the internal DSBPOSITIONNOTIFY structures of the 
//              TDSBPositionNotify component. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDSBPositionNotify::ClearAll()
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDSBPositionNotify::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }

ZeroMemory( &fDSBPOSITIONNOTIFY[0], sizeof(DSBPOSITIONNOTIFY)*fArraySize );
}


// --------------------------------------------------------------------------
// Internal Structure Access 
// --------------------------------------------------------------------------
DSBPOSITIONNOTIFY* __fastcall TDSBPositionNotify::FGetInternal_DSBPOSITIONNOTIFY_Ptr()
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDSBPositionNotify::FGetInternal_DSBPOSITIONNOTIFY_Ptr()", "TDX_ERROR", "Internal Array size is 0." );
    return NULL;
    }
return fDSBPOSITIONNOTIFY;
}
// --------------------------------------------------------------------------
void __fastcall TDSBPositionNotify::FSetInternal_DSBPOSITIONNOTIFY( dword pArrayIndex, DSBPOSITIONNOTIFY* pDSBPOSITIONNOTIFY )
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDSBPositionNotify::FSetInternal_DSBPOSITIONNOTIFY()", "TDX_ERROR", "Internal Array size is 0." );
    return;
    }
if (pDSBPOSITIONNOTIFY==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDSBPositionNotify::FSetInternal_DSBPOSITIONNOTIFY()", "TDX_ERROR", "The supplied DSBPOSITIONNOTIFY* was NULL" );
    return;
    }
CopyMemory( &fDSBPOSITIONNOTIFY[pArrayIndex], pDSBPOSITIONNOTIFY, sizeof(DSBPOSITIONNOTIFY) );
Internal_DSBPOSITIONNOTIFY_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDSBPositionNotify::Internal_DSBPOSITIONNOTIFY_Update()
{
}

// --------------------------------------------------------------------------
