// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDSCBufferDesc.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               
// Description:  This file contains the code for the TDSCBufferDesc Component 
//
// "TDx_Sound_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDSCBufferDesc.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Sound_Library_Defns"
#pragma link "TDx_Sound_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDSCBufferDesc*)
{
    new TDSCBufferDesc(NULL);
}
// --------------------------------------------------------------------------
namespace Tdscbufferdesc
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDSCBufferDesc)};
        RegisterComponents("TDx_Sound", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDSCBufferDesc::TDSCBufferDesc()
// Description: The default constructor for the TDSCBufferDesc object.
// --------------------------------------------------------------------------
__fastcall TDSCBufferDesc::TDSCBufferDesc(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDSCBufferDesc::~TDSCBufferDesc()
// Description: The destructor for the TDSCBufferDesc object.
// --------------------------------------------------------------------------
__fastcall TDSCBufferDesc::~TDSCBufferDesc()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    BufferBytes
// Description: The BufferBytes property defines the size, in bytes, of the 
//              new capture buffer. 
// --------------------------------------------------------------------------
dword __fastcall TDSCBufferDesc::FGetBufferBytes()
{
return fDSCBUFFERDESC.dwBufferBytes;
}
// --------------------------------------------------------------------------
void __fastcall TDSCBufferDesc::FSetBufferBytes( dword pBufferBytes )
{
fDSCBUFFERDESC.dwBufferBytes = pBufferBytes;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDSCBufferDesc method or fget/fset. 
//              eg. DS_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDSCBufferDesc::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDSCBufferDesc::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines a flag indicating capture buffer 
//              capabilities. 
//              The described effect applies when the flag is set. 
// Flags:       DSCBCAPS_WAVEMAPPED -
//                Unsupported sound formats will use the Win32 wave mapper. 
// --------------------------------------------------------------------------
dword __fastcall TDSCBufferDesc::FGetFlags()
{
return fDSCBUFFERDESC.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDSCBufferDesc::FSetFlags( dword pFlags )
{
fDSCBUFFERDESC.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    Format
// Description: The Format property references a WAVEFORMATEX object defining 
//              the waveform format of the new capture buffer. 
// --------------------------------------------------------------------------
WAVEFORMATEX* __fastcall TDSCBufferDesc::FGetFormat()
{
return fDSCBUFFERDESC.lpwfxFormat;
}
// --------------------------------------------------------------------------
void __fastcall TDSCBufferDesc::FSetFormat( WAVEFORMATEX* pFormat )
{
fDSCBUFFERDESC.lpwfxFormat = pFormat;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDSCBufferDesc::FGetSize()
{
return fDSCBUFFERDESC.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDSCBufferDesc::FSetSize( dword pSize )
{
fDSCBUFFERDESC.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDSCBufferDesc's internal DSCBUFFERDESC structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDSCBufferDesc::Clear()
{
fDSCBUFFERDESC.dwBufferBytes = 0;
fErrorValue = DS_OK;
fDSCBUFFERDESC.dwFlags = 0;
fDSCBUFFERDESC.dwSize = sizeof(DSCBUFFERDESC);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DSCBUFFERDESC* __fastcall TDSCBufferDesc::FGetInternal_DSCBUFFERDESC_Ptr()
{
return &fDSCBUFFERDESC;
}
// --------------------------------------------------------------------------
void __fastcall TDSCBufferDesc::FSetInternal_DSCBUFFERDESC( DSCBUFFERDESC* pDSCBUFFERDESC )
{
if (pDSCBUFFERDESC==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDSCBufferDesc::FSetInternal_DSCBUFFERDESC()", "TDX_ERROR", "The supplied DSCBUFFERDESC* was NULL" );
    return;
    }

CopyMemory( &fDSCBUFFERDESC, pDSCBUFFERDESC, sizeof(DSCBUFFERDESC) );
Internal_DSCBUFFERDESC_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDSCBufferDesc::Internal_DSCBUFFERDESC_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDSCBufferDesc_Flags_Set<> of the flags 
//              in the current fDSCBUFFERDESC.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDSCBufferDesc_Flags_Set __fastcall TDSCBufferDesc::FGetFlags_()
{
TDSCBufferDesc_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDSCBUFFERDESC.dwFlags & DSCBCAPS_WAVEMAPPED) TempFlags_ = TempFlags_ << dscbcaps_wavemapped;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDSCBufferDesc::FSetFlags_( TDSCBufferDesc_Flags_Set pFlags_ )
{
fDSCBUFFERDESC.dwFlags = 0;
if (pFlags_.Contains(dscbcaps_wavemapped)) fDSCBUFFERDESC.dwFlags |= DSCBCAPS_WAVEMAPPED;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDSCBufferDesc::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDSCBufferDesc::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDSCBUFFERDESC.dwFlags & DSCBCAPS_WAVEMAPPED) fFlags_Strings->Add("DSCBCAPS_WAVEMAPPED");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
