// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDSCaps.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               
// Description:  This file contains the code for the TDSCaps Component 
//
// "TDx_Sound_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDSCaps.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Sound_Library_Defns"
#pragma link "TDx_Sound_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDSCaps*)
{
    new TDSCaps(NULL);
}
// --------------------------------------------------------------------------
namespace Tdscaps
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDSCaps)};
        RegisterComponents("TDx_Sound", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDSCaps::TDSCaps()
// Description: The default constructor for the TDSCaps object.
// --------------------------------------------------------------------------
__fastcall TDSCaps::TDSCaps(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDSCaps::~TDSCaps()
// Description: The destructor for the TDSCaps object.
// --------------------------------------------------------------------------
__fastcall TDSCaps::~TDSCaps()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDSCaps method or fget/fset. eg. 
//              DS_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDSCaps::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags specifying the available 
//              device capabilities. 
//              The described effect applies when the flag is set. 
// Flags:       DSCAPS_CERTIFIED -
//                The sound card driver has been tested and certified by 
//                Microsoft. 
//              DSCAPS_CONTINUOUSRATE -
//                Support for all sample rates falling between the values of 
//                TDSCaps::MinSecondarySampleRate and 
//                TDSCaps::MaxSecondarySampleRate is available. 
//                This usually means actual output rates will be within +/- 
//                10 hertz (Hz) of the desired frequency. 
//              DSCAPS_EMULDRIVER -
//                There is no DirectSound driver installed for the device, so 
//                it is being emulated through the Windows waveform-audio 
//                functions. 
//                Expect some degree of performance degradation. 
//              DSCAPS_PRIMARY16BIT -
//                Support for primary sound buffers with 16 bit samples is 
//                available. 
//              DSCAPS_PRIMARY8BIT -
//                Support for primary sound buffers with 8 bit samples is 
//                available. 
//              DSCAPS_PRIMARYMONO -
//                Support for monophonic primary sound buffers is available. 
//              DSCAPS_PRIMARYSTEREO -
//                Support for stereo primary sound buffers is available. 
//              DSCAPS_SECONDARY16BIT -
//                Support for hardware mixed secondary sound buffers with 16 
//                bit samples is available. 
//              DSCAPS_SECONDARY8BIT -
//                Support for hardware mixed secondary sound buffers with 8 
//                bit samples is available. 
//              DSCAPS_SECONDARYMONO -
//                Support for hardware mixed monophonic secondary buffers is 
//                available. 
//              DSCAPS_SECONDARYSTEREO -
//                Support for hardware mixed stereo secondary buffers is 
//                available. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetFlags()
{
return fDSCAPS.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetFlags( dword pFlags )
{
fDSCAPS.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    FreeHw3DAllBuffers
// Description: The FreeHw3DAllBuffers property defines the amount of 
//              unallocated 3D positional capability the hardware has 
//              available for all buffers. 
//              By comparing this property with TDSCaps::MaxHw3DAllBuffers, a 
//              value for the resources already allocated can be determined. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetFreeHw3DAllBuffers()
{
return fDSCAPS.dwFreeHw3DAllBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetFreeHw3DAllBuffers( dword pFreeHw3DAllBuffers )
{
fDSCAPS.dwFreeHw3DAllBuffers = pFreeHw3DAllBuffers;
}
// --------------------------------------------------------------------------
// Property:    FreeHw3DStaticBuffers
// Description: The FreeHw3DStaticBuffers property defines the amount of 
//              unallocated 3D positional capability the hardware has 
//              available for static buffers. 
//              By comparing this property with 
//              TDSCaps::MaxHw3DStaticBuffers, a value for the resources 
//              already allocated can be determined. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetFreeHw3DStaticBuffers()
{
return fDSCAPS.dwFreeHw3DStaticBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetFreeHw3DStaticBuffers( dword pFreeHw3DStaticBuffers )
{
fDSCAPS.dwFreeHw3DStaticBuffers = pFreeHw3DStaticBuffers;
}
// --------------------------------------------------------------------------
// Property:    FreeHw3DStreamingBuffers
// Description: The FreeHw3DStreamingBuffers property defines the amount of 
//              unallocated 3D positional capability the hardware has 
//              available for streaming buffers. 
//              By comparing this property with 
//              TDSCaps::MaxHw3DStreamingBuffers, a value for the resources 
//              already allocated can be determined. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetFreeHw3DStreamingBuffers()
{
return fDSCAPS.dwFreeHw3DStreamingBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetFreeHw3DStreamingBuffers( dword pFreeHw3DStreamingBuffers )
{
fDSCAPS.dwFreeHw3DStreamingBuffers = pFreeHw3DStreamingBuffers;
}
// --------------------------------------------------------------------------
// Property:    FreeHwMemBytes
// Description: The FreeHwMemBytes property defines the amount, in bytes, of 
//              memory on the sound card that is unallocated. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetFreeHwMemBytes()
{
return fDSCAPS.dwFreeHwMemBytes;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetFreeHwMemBytes( dword pFreeHwMemBytes )
{
fDSCAPS.dwFreeHwMemBytes = pFreeHwMemBytes;
}
// --------------------------------------------------------------------------
// Property:    FreeHwMixingAllBuffers
// Description: The FreeHwMixingAllBuffers property defines the amount of 
//              unallocated mixing capability the hardware has available for 
//              all buffers. 
//              By comparing this property with 
//              TDSCaps::MaxHwMixingAllBuffers, a value for the resources 
//              already allocated can be determined. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetFreeHwMixingAllBuffers()
{
return fDSCAPS.dwFreeHwMixingAllBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetFreeHwMixingAllBuffers( dword pFreeHwMixingAllBuffers )
{
fDSCAPS.dwFreeHwMixingAllBuffers = pFreeHwMixingAllBuffers;
}
// --------------------------------------------------------------------------
// Property:    FreeHwMixingStaticBuffers
// Description: The FreeHwMixingStaticBuffers property defines the amount of 
//              unallocated mixing capability the hardware has available for 
//              static buffers. 
//              By comparing this property with 
//              TDSCaps::MaxHwMixingStaticBuffers, a value for the resources 
//              already allocated can be determined. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetFreeHwMixingStaticBuffers()
{
return fDSCAPS.dwFreeHwMixingStaticBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetFreeHwMixingStaticBuffers( dword pFreeHwMixingStaticBuffers )
{
fDSCAPS.dwFreeHwMixingStaticBuffers = pFreeHwMixingStaticBuffers;
}
// --------------------------------------------------------------------------
// Property:    FreeHwMixingStreamingBuffers
// Description: The FreeHwMixingStreamingBuffers property defines the amount 
//              of unallocated mixing capability the hardware has available 
//              for streaming buffers. 
//              By comparing this property with 
//              TDSCaps::MaxHwMixingStreamingBuffers, a value for the 
//              resources already allocated can be determined. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetFreeHwMixingStreamingBuffers()
{
return fDSCAPS.dwFreeHwMixingStreamingBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetFreeHwMixingStreamingBuffers( dword pFreeHwMixingStreamingBuffers )
{
fDSCAPS.dwFreeHwMixingStreamingBuffers = pFreeHwMixingStreamingBuffers;
}
// --------------------------------------------------------------------------
// Property:    MaxContigFreeHwMemBytes
// Description: The MaxContigFreeHwMemBytes property defines the size, in 
//              bytes, of the largest contiguous block of memory on the sound 
//              card that is unallocated. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetMaxContigFreeHwMemBytes()
{
return fDSCAPS.dwMaxContigFreeHwMemBytes;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetMaxContigFreeHwMemBytes( dword pMaxContigFreeHwMemBytes )
{
fDSCAPS.dwMaxContigFreeHwMemBytes = pMaxContigFreeHwMemBytes;
}
// --------------------------------------------------------------------------
// Property:    MaxHw3DAllBuffers
// Description: The MaxHw3DAllBuffers property defines the total amount of 3D 
//              positional capability the hardware has for all buffers. 
//              By comparing this property with TDSCaps::FreeHw3DAllBuffers, 
//              a value for the resources already allocated can be 
//              determined. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetMaxHw3DAllBuffers()
{
return fDSCAPS.dwMaxHw3DAllBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetMaxHw3DAllBuffers( dword pMaxHw3DAllBuffers )
{
fDSCAPS.dwMaxHw3DAllBuffers = pMaxHw3DAllBuffers;
}
// --------------------------------------------------------------------------
// Property:    MaxHw3DStaticBuffers
// Description: The MaxHw3DStaticBuffers property defines the total amount of 
//              3D positional capability the hardware has for static buffers. 
//              By comparing this property with 
//              TDSCaps::FreeHw3DStaticBuffers, a value for the resources 
//              already allocated can be determined. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetMaxHw3DStaticBuffers()
{
return fDSCAPS.dwMaxHw3DStaticBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetMaxHw3DStaticBuffers( dword pMaxHw3DStaticBuffers )
{
fDSCAPS.dwMaxHw3DStaticBuffers = pMaxHw3DStaticBuffers;
}
// --------------------------------------------------------------------------
// Property:    MaxHw3DStreamingBuffers
// Description: The MaxHw3DStreamingBuffers property defines the total amount 
//              of 3D positional capability the hardware has for streaming 
//              buffers. 
//              By comparing this property with 
//              TDSCaps::FreeHw3DStreamingBuffers, a value for the resources 
//              already allocated can be determined. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetMaxHw3DStreamingBuffers()
{
return fDSCAPS.dwMaxHw3DStreamingBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetMaxHw3DStreamingBuffers( dword pMaxHw3DStreamingBuffers )
{
fDSCAPS.dwMaxHw3DStreamingBuffers = pMaxHw3DStreamingBuffers;
}
// --------------------------------------------------------------------------
// Property:    MaxHwMixingAllBuffers
// Description: The MaxHwMixingAllBuffers property defines the total number 
//              of mixing buffers the hardware offers for all buffer types. 
//              By comparing this property with 
//              TDSCaps::FreeHwMixingAllBuffers, a value for the resources 
//              already allocated can be determined. 
//              This property may be less than the sum of 
//              TDSCaps::MaxHwMixingStaticBuffers and 
//              TDSCaps::MaxHwMixingStreamingBuffers. Resource tradeoffs 
//              frequently occur. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetMaxHwMixingAllBuffers()
{
return fDSCAPS.dwMaxHwMixingAllBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetMaxHwMixingAllBuffers( dword pMaxHwMixingAllBuffers )
{
fDSCAPS.dwMaxHwMixingAllBuffers = pMaxHwMixingAllBuffers;
}
// --------------------------------------------------------------------------
// Property:    MaxHwMixingStaticBuffers
// Description: The MaxHwMixingStaticBuffers property defines the total 
//              number of mixing buffers the hardware offers for all static 
//              buffers. 
//              By comparing this property with 
//              TDSCaps::FreeHwMixingStaticBuffers, a value for the resources 
//              already allocated can be determined. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetMaxHwMixingStaticBuffers()
{
return fDSCAPS.dwMaxHwMixingStaticBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetMaxHwMixingStaticBuffers( dword pMaxHwMixingStaticBuffers )
{
fDSCAPS.dwMaxHwMixingStaticBuffers = pMaxHwMixingStaticBuffers;
}
// --------------------------------------------------------------------------
// Property:    MaxHwMixingStreamingBuffers
// Description: The MaxHwMixingStreamingBuffers property defines the total 
//              number of mixing buffers the hardware offers for all 
//              streaming buffers. 
//              By comparing this property with 
//              TDSCaps::FreeHwMixingStreamingBuffers, a value for the 
//              resources already allocated can be determined. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetMaxHwMixingStreamingBuffers()
{
return fDSCAPS.dwMaxHwMixingStreamingBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetMaxHwMixingStreamingBuffers( dword pMaxHwMixingStreamingBuffers )
{
fDSCAPS.dwMaxHwMixingStreamingBuffers = pMaxHwMixingStreamingBuffers;
}
// --------------------------------------------------------------------------
// Property:    MaxSecondarySampleRate
// Description: The MaxSecondarySampleRate property defines the maximum 
//              sample rate that the hardware's secondary sound buffers can 
//              support. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetMaxSecondarySampleRate()
{
return fDSCAPS.dwMaxSecondarySampleRate;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetMaxSecondarySampleRate( dword pMaxSecondarySampleRate )
{
fDSCAPS.dwMaxSecondarySampleRate = pMaxSecondarySampleRate;
}
// --------------------------------------------------------------------------
// Property:    MinSecondarySampleRate
// Description: The MinSecondarySampleRate property defines the minimum 
//              sample rate that the hardware's secondary sound buffers can 
//              support. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetMinSecondarySampleRate()
{
return fDSCAPS.dwMinSecondarySampleRate;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetMinSecondarySampleRate( dword pMinSecondarySampleRate )
{
fDSCAPS.dwMinSecondarySampleRate = pMinSecondarySampleRate;
}
// --------------------------------------------------------------------------
// Property:    PlayCpuOverheadSwBuffers
// Description: The PlayCpuOverheadSwBuffers property represents the 
//              percentage of main processing cycles needed to mix sound 
//              buffers located in system memory. 
//              This value will depend on the bus type, processor type and 
//              clock speed. 
//              The overhead of a hardware buffer will be zero because the 
//              mixing is done by the sound device. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetPlayCpuOverheadSwBuffers()
{
return fDSCAPS.dwPlayCpuOverheadSwBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetPlayCpuOverheadSwBuffers( dword pPlayCpuOverheadSwBuffers )
{
fDSCAPS.dwPlayCpuOverheadSwBuffers = pPlayCpuOverheadSwBuffers;
}
// --------------------------------------------------------------------------
// Property:    PrimaryBuffers
// Description: The PrimaryBuffers property defines the number of primary 
//              buffers that are supported. 
//              This value will always be 1. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetPrimaryBuffers()
{
return fDSCAPS.dwPrimaryBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetPrimaryBuffers( dword pPrimaryBuffers )
{
fDSCAPS.dwPrimaryBuffers = pPrimaryBuffers;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetSize()
{
return fDSCAPS.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetSize( dword pSize )
{
fDSCAPS.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    TotalHwMemBytes
// Description: The TotalHwMemBytes property defines the total amount, in 
//              bytes, of the memory on the sound card that is used for 
//              storing static sound buffers. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetTotalHwMemBytes()
{
return fDSCAPS.dwTotalHwMemBytes;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetTotalHwMemBytes( dword pTotalHwMemBytes )
{
fDSCAPS.dwTotalHwMemBytes = pTotalHwMemBytes;
}
// --------------------------------------------------------------------------
// Property:    UnlockTransferRateHwBuffers
// Description: The UnlockTransferRateHwBuffers property describes the rate, 
//              in kilobytes per second, at which data is transferred to 
//              hardware static sound buffers when TDx_SoundBuffer::Unlock() 
//              is called. 
//              This value, along with the number of bytes, can be used by 
//              applications to determine the time required for 
//              TDx_SoundBuffer::Unlock() to execute. 
//              The transfer rate for a software buffer is zero because the 
//              data does not need to be tansferred anywhere. 
// --------------------------------------------------------------------------
dword __fastcall TDSCaps::FGetUnlockTransferRateHwBuffers()
{
return fDSCAPS.dwUnlockTransferRateHwBuffers;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetUnlockTransferRateHwBuffers( dword pUnlockTransferRateHwBuffers )
{
fDSCAPS.dwUnlockTransferRateHwBuffers = pUnlockTransferRateHwBuffers;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDSCaps's internal DSCAPS structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDSCaps::Clear()
{
fErrorValue = DS_OK;
fDSCAPS.dwFlags = 0;
fDSCAPS.dwFreeHw3DAllBuffers = 0;
fDSCAPS.dwFreeHw3DStaticBuffers = 0;
fDSCAPS.dwFreeHw3DStreamingBuffers = 0;
fDSCAPS.dwFreeHwMemBytes = 0;
fDSCAPS.dwFreeHwMixingAllBuffers = 0;
fDSCAPS.dwFreeHwMixingStaticBuffers = 0;
fDSCAPS.dwFreeHwMixingStreamingBuffers = 0;
fDSCAPS.dwMaxContigFreeHwMemBytes = 0;
fDSCAPS.dwMaxHw3DAllBuffers = 0;
fDSCAPS.dwMaxHw3DStaticBuffers = 0;
fDSCAPS.dwMaxHw3DStreamingBuffers = 0;
fDSCAPS.dwMaxHwMixingAllBuffers = 0;
fDSCAPS.dwMaxHwMixingStaticBuffers = 0;
fDSCAPS.dwMaxHwMixingStreamingBuffers = 0;
fDSCAPS.dwMaxSecondarySampleRate = 0;
fDSCAPS.dwMinSecondarySampleRate = 0;
fDSCAPS.dwPlayCpuOverheadSwBuffers = 0;
fDSCAPS.dwPrimaryBuffers = 0;
fDSCAPS.dwSize = sizeof(DSCAPS);
fDSCAPS.dwTotalHwMemBytes = 0;
fDSCAPS.dwUnlockTransferRateHwBuffers = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DSCAPS* __fastcall TDSCaps::FGetInternal_DSCAPS_Ptr()
{
return &fDSCAPS;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetInternal_DSCAPS( DSCAPS* pDSCAPS )
{
if (pDSCAPS==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDSCaps::FSetInternal_DSCAPS()", "TDX_ERROR", "The supplied DSCAPS* was NULL" );
    return;
    }

CopyMemory( &fDSCAPS, pDSCAPS, sizeof(DSCAPS) );
Internal_DSCAPS_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::Internal_DSCAPS_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDSCaps_Flags_Set<> of the flags in the 
//              current fDSCAPS.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDSCaps_Flags_Set __fastcall TDSCaps::FGetFlags_()
{
TDSCaps_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDSCAPS.dwFlags & DSCAPS_CERTIFIED) TempFlags_ = TempFlags_ << dscaps_certified_;
if (fDSCAPS.dwFlags & DSCAPS_CONTINUOUSRATE) TempFlags_ = TempFlags_ << dscaps_continuousrate;
if (fDSCAPS.dwFlags & DSCAPS_EMULDRIVER) TempFlags_ = TempFlags_ << dscaps_emuldriver;
if (fDSCAPS.dwFlags & DSCAPS_PRIMARY16BIT) TempFlags_ = TempFlags_ << dscaps_primary16bit;
if (fDSCAPS.dwFlags & DSCAPS_PRIMARY8BIT) TempFlags_ = TempFlags_ << dscaps_primary8bit;
if (fDSCAPS.dwFlags & DSCAPS_PRIMARYMONO) TempFlags_ = TempFlags_ << dscaps_primarymono;
if (fDSCAPS.dwFlags & DSCAPS_PRIMARYSTEREO) TempFlags_ = TempFlags_ << dscaps_primarystereo;
if (fDSCAPS.dwFlags & DSCAPS_SECONDARY16BIT) TempFlags_ = TempFlags_ << dscaps_secondary16bit;
if (fDSCAPS.dwFlags & DSCAPS_SECONDARY8BIT) TempFlags_ = TempFlags_ << dscaps_secondary8bit;
if (fDSCAPS.dwFlags & DSCAPS_SECONDARYMONO) TempFlags_ = TempFlags_ << dscaps_secondarymono;
if (fDSCAPS.dwFlags & DSCAPS_SECONDARYSTEREO) TempFlags_ = TempFlags_ << dscaps_secondarystereo;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDSCaps::FSetFlags_( TDSCaps_Flags_Set pFlags_ )
{
fDSCAPS.dwFlags = 0;
if (pFlags_.Contains(dscaps_certified_)) fDSCAPS.dwFlags |= DSCAPS_CERTIFIED;
if (pFlags_.Contains(dscaps_continuousrate)) fDSCAPS.dwFlags |= DSCAPS_CONTINUOUSRATE;
if (pFlags_.Contains(dscaps_emuldriver)) fDSCAPS.dwFlags |= DSCAPS_EMULDRIVER;
if (pFlags_.Contains(dscaps_primary16bit)) fDSCAPS.dwFlags |= DSCAPS_PRIMARY16BIT;
if (pFlags_.Contains(dscaps_primary8bit)) fDSCAPS.dwFlags |= DSCAPS_PRIMARY8BIT;
if (pFlags_.Contains(dscaps_primarymono)) fDSCAPS.dwFlags |= DSCAPS_PRIMARYMONO;
if (pFlags_.Contains(dscaps_primarystereo)) fDSCAPS.dwFlags |= DSCAPS_PRIMARYSTEREO;
if (pFlags_.Contains(dscaps_secondary16bit)) fDSCAPS.dwFlags |= DSCAPS_SECONDARY16BIT;
if (pFlags_.Contains(dscaps_secondary8bit)) fDSCAPS.dwFlags |= DSCAPS_SECONDARY8BIT;
if (pFlags_.Contains(dscaps_secondarymono)) fDSCAPS.dwFlags |= DSCAPS_SECONDARYMONO;
if (pFlags_.Contains(dscaps_secondarystereo)) fDSCAPS.dwFlags |= DSCAPS_SECONDARYSTEREO;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDSCaps::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDSCaps::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDSCAPS.dwFlags & DSCAPS_CERTIFIED) fFlags_Strings->Add("DSCAPS_CERTIFIED");
if (fDSCAPS.dwFlags & DSCAPS_CONTINUOUSRATE) fFlags_Strings->Add("DSCAPS_CONTINUOUSRATE");
if (fDSCAPS.dwFlags & DSCAPS_EMULDRIVER) fFlags_Strings->Add("DSCAPS_EMULDRIVER");
if (fDSCAPS.dwFlags & DSCAPS_PRIMARY16BIT) fFlags_Strings->Add("DSCAPS_PRIMARY16BIT");
if (fDSCAPS.dwFlags & DSCAPS_PRIMARY8BIT) fFlags_Strings->Add("DSCAPS_PRIMARY8BIT");
if (fDSCAPS.dwFlags & DSCAPS_PRIMARYMONO) fFlags_Strings->Add("DSCAPS_PRIMARYMONO");
if (fDSCAPS.dwFlags & DSCAPS_PRIMARYSTEREO) fFlags_Strings->Add("DSCAPS_PRIMARYSTEREO");
if (fDSCAPS.dwFlags & DSCAPS_SECONDARY16BIT) fFlags_Strings->Add("DSCAPS_SECONDARY16BIT");
if (fDSCAPS.dwFlags & DSCAPS_SECONDARY8BIT) fFlags_Strings->Add("DSCAPS_SECONDARY8BIT");
if (fDSCAPS.dwFlags & DSCAPS_SECONDARYMONO) fFlags_Strings->Add("DSCAPS_SECONDARYMONO");
if (fDSCAPS.dwFlags & DSCAPS_SECONDARYSTEREO) fFlags_Strings->Add("DSCAPS_SECONDARYSTEREO");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
