// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDx_Sound3DBuffer.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               
// Description:  This file contains the code for the TDx_Sound3DBuffer 
//               Component 
//
// "TDx_Sound_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDx_Sound3DBuffer.H"
// --------------------------------------------------------------------------
// external classes used by the TDx_Sound3DBuffer component.
#include "TDx_SoundBuffer.H"
// --------------------------------------------------------------------------
// external classes used by TDx_Sound3DBuffer methods.
#include "TDS3DBuffer.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Sound_Library_Defns"
#pragma link "TDx_Sound_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDx_Sound3DBuffer*)
{
    new TDx_Sound3DBuffer(NULL);
}
// --------------------------------------------------------------------------
namespace Tdx_sound3dbuffer
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDx_Sound3DBuffer)};
        RegisterComponents("TDx_Sound", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDx_Sound3DBuffer::TDx_Sound3DBuffer()
// Description: The default constructor for the TDx_Sound3DBuffer object.
// --------------------------------------------------------------------------
__fastcall TDx_Sound3DBuffer::TDx_Sound3DBuffer(TComponent* Owner)
    : TComponent(Owner)
{
fCreated = false;
fErrorValue = DS_OK;
}
// --------------------------------------------------------------------------
// Destructor:  TDx_Sound3DBuffer::~TDx_Sound3DBuffer()
// Description: The destructor for the TDx_Sound3DBuffer object.
// --------------------------------------------------------------------------
__fastcall TDx_Sound3DBuffer::~TDx_Sound3DBuffer()
{
// destroy internals
if (Created) Destroy();
}
// --------------------------------------------------------------------------
// Property:    Created
// Description: The Created property is true if the internal 
//              LPDIRECTSOUND3DBUFFER used in this component has been 
//              successfully created, otherwise Created is false. 
//              
//              To create the internal LPDIRECTSOUND3DBUFFER, call the 
//              TDx_Sound3DBuffer::Create() method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::FGetCreated()
{
return fCreated;
}
// --------------------------------------------------------------------------
void __fastcall TDx_Sound3DBuffer::FSetCreated( bool pCreated )
{
fCreated = (pCreated && (fLPDIRECTSOUND3DBUFFER==NULL));
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDx_Sound3DBuffer method or 
//              fget/fset. eg. DS_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDx_Sound3DBuffer::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDx_Sound3DBuffer::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Method:      Create()
// Description: The Create() method is used to automatically create the 
//              internal LPDIRECTSOUND3DBUFFER interface used in the 
//              TDx_Sound3DBuffer component and must be called before any 
//              methods of the TDx_Sound3DBuffer component will function. 
// Params:      pSoundBuffer - 
//                The SoundBuffer parameter references the existing 
//                TDx_SoundBuffer component for which the TDx_Sound3DBuffer is 
//                to be created. The sound buffer referenced by this parameter 
//                must have been created with the DSBCAPS_CTRL3D flag set. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::Create( TDx_SoundBuffer* pSoundBuffer )
{
// if the component internals have already been created, exit
if (fCreated)
    {
    fErrorValue = TDX_ALREADYCREATED;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ALREADYCREATED", "The "+Name+"::Create() method was called when the component has already been created successfully." );
    return false;
    }

// check params for accuracy
if (pSoundBuffer==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_BADPARAMS", "The 'pSoundBuffer' parameter must point to an existing TDx_SoundBuffer component and cannot be NULL." );
    return false;
    }

// check that the sound buffer has been created
if (!pSoundBuffer->Created) 
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", "The TDx_Sound3DBuffer cannot be created because the TDx_SoundBuffer component specified by the 'pSoundBuffer' parameter has not yet been created." );
    return false;
    }

// code that creates the internal IDirectSound3DBuffer interface
fErrorValue = pSoundBuffer->Internal_LPDIRECTSOUNDBUFFER->QueryInterface( IID_IDirectSound3DBuffer, (LPVOID*)&fLPDIRECTSOUND3DBUFFER);

if (fErrorValue!=DS_OK)
    {
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", "The "+Name+"::Create() method failed because LPDIRECTSOUNDBUFFER->QueryInterface(IID_IDirectSound3DBuffer) failed with error: "+TDx_Sound_Library_ErrorString(fErrorValue)+", "+TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// successfully created
fCreated = true;
if (FOnCreate) FOnCreate(this);
return true;
}

// --------------------------------------------------------------------------
// Method:      Destroy()
// Description: The Destroy() method is used to automatically destroy the 
//              internal LPDIRECTSOUND3DBUFFER interface used in the 
//              TDx_Sound3DBuffer component and should be called when the 
//              internal interface is no longer required. 
//              
//              Note: This method is called by the component's destructor. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::Destroy()
{
// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_NOTCREATED", "The "+Name+"::Destroy() method was called before being created successfully." );
    return false;
    }

// code that destroys the internal interface
if (FOnDestroy) FOnDestroy(this);

if (fLPDIRECTSOUND3DBUFFER==NULL) 
    { 
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "The "+Name+" component's internal LPDIRECTSOUND3DBUFFER is NULL but the TDx_Sound component is expecting it to be not NULL. Aborting the Destroy()." );
    return false;
    }

try { 
    fLPDIRECTSOUND3DBUFFER->Release(); 
    } 
catch (...) 
    { 
    fErrorValue = TDX_ERROR; 
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "An exception has occurred within LPDIRECTSOUND3DBUFFER->Release(). Check that you are destroying all components in reverse order of creation." );
    }

// successful destruction
fLPDIRECTSOUND3DBUFFER = NULL;
fCreated = false;
return true;
}

// --------------------------------------------------------------------------
// Method:      GetAllParameters()
// Description: The TDx_Sound3DBuffer::GetAllParameters method will return 
//              the current 3D characteristics of the sound buffer. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pBuffer3D - 
//                The Buffer3D parameter references a TDS3DBuffer component for 
//                holding the current 3D characteristics of the sound buffer if 
//                this method returns successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::GetAllParameters( TDS3DBuffer* pBuffer3D )
{
// Original Function Definition
// HRESULT GetAllParameters( 
//   LPDS3DBUFFER lpDs3dBuffer   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetAllParameters()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pBuffer3D==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetAllParameters()", "TDX_BADPARAMS", "'pBuffer3D' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->GetAllParameters( pBuffer3D->Internal_DS3DBUFFER_Ptr );

// Translate Data returned from Function
pBuffer3D->Internal_DS3DBUFFER_Update();

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetAllParameters()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetConeAngles()
// Description: The TDx_Sound3DBuffer::GetConeAngles method will return the 
//              inside and outside sound projection cone angles of the sound 
//              buffer. 
//              
//              The minimum, maximum and default cone angles are defined in 
//              the dsound.h DS3D_MINCONEANGLE, DS3D_MAXCONEANGLE and 
//              DS3D_DEFAULTCONEANGLE members as 0, 360 and 360 degrees 
//              respectively. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pInsideConeAngle - 
//                The InsideConeAngle parameter will reference the inside sound 
//                projection cone angle, in degrees, if this method returns 
//                successsfully. 
//              pOutsideConeAngle - 
//                The OutsideConeAngle parameter will reference the outside 
//                sound projection cone angle, in degrees, if this method 
//                returns successsfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::GetConeAngles( dword* pInsideConeAngle, dword* pOutsideConeAngle )
{
// Original Function Definition
// HRESULT GetConeAngles( 
//   LPDWORD lpdwInsideConeAngle,   
//   LPDWORD lpdwOutsideConeAngle   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetConeAngles()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pInsideConeAngle==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetConeAngles()", "TDX_BADPARAMS", "'pInsideConeAngle' cannot be 'NULL'");
    return false;
    }
if (pOutsideConeAngle==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetConeAngles()", "TDX_BADPARAMS", "'pOutsideConeAngle' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->GetConeAngles( (LPDWORD) pInsideConeAngle, (LPDWORD) pOutsideConeAngle );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetConeAngles()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetConeOrientation()
// Description: The TDx_Sound3DBuffer::GetConeOrientation method will return 
//              the sound projection cone orientation of the sound buffer. 
//              
//              Orientation vectors are adjusted so as to have a magnitude of 
//              1 or less. Thus the value retrieved may not be the same as 
//              the value set. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pOrientation - 
//                The Orientation parameter references a D3DVECTOR for holding 
//                the current sound projection cone orientation if this method 
//                returns successfully. 
//                The vector represents the center of the sound cone. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::GetConeOrientation( D3DVECTOR* pOrientation )
{
// Original Function Definition
// HRESULT GetConeOrientation( 
//   LPD3DVECTOR lpvOrientation   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetConeOrientation()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pOrientation==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetConeOrientation()", "TDX_BADPARAMS", "'pOrientation' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->GetConeOrientation( (LPD3DVECTOR) pOrientation );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetConeOrientation()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetConeOutsideVolume()
// Description: The TDx_Sound3DBuffer::GetConeOutsideVolume method will 
//              return the current volume, in 100ths of a decibel, set for 
//              the outside cone of the sound buffer. 
//              
//              This volume is expressed as an attenuation value and is 
//              subtracted from the normal volume levels. 
//              
//              The minimum, maximum and default cone outside volumes are 
//              defined in the dsound.h DSBVOLUME_MIN, DSBVOLUME_MAX and 
//              DS3D_DEFAULTCONEOUTSIDEVOLUME members as -10000, 0 and 0 
//              respectively. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pConeOutsideVolume - 
//                The ConeOutsideVolume parameter will reference the current 
//                volume setting for the outside cone of the buffer if this 
//                method returns successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::GetConeOutsideVolume( long* pConeOutsideVolume )
{
// Original Function Definition
// HRESULT GetConeOutsideVolume( 
//   LPLONG lplConeOutsideVolume   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetConeOutsideVolume()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pConeOutsideVolume==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetConeOutsideVolume()", "TDX_BADPARAMS", "'pConeOutsideVolume' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->GetConeOutsideVolume( (LPLONG) pConeOutsideVolume );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetConeOutsideVolume()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetMaxDistance()
// Description: The TDx_Sound3DBuffer::GetMaxDistance method will return the 
//              maximum distance, in distance units, currently set for the 
//              sound buffer. 
//              
//              The default maximum distance is defined in the dsound.h 
//              DS3D_DEFAULTMAXDISTANCE member as 1000000000.0 and as such 
//              can be regarded as effectively infinite. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pMaxDistance - 
//                The MaxDistance parameter will reference the maximum distance 
//                currently set for the buffer if this method returns 
//                successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::GetMaxDistance( D3DVALUE* pMaxDistance )
{
// Original Function Definition
// HRESULT GetMaxDistance( 
//   LPD3DVALUE lpflMaxDistance   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetMaxDistance()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pMaxDistance==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetMaxDistance()", "TDX_BADPARAMS", "'pMaxDistance' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->GetMaxDistance( (LPD3DVALUE) pMaxDistance );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetMaxDistance()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetMinDistance()
// Description: The TDx_Sound3DBuffer::GetMinDistance method will return the 
//              minimum distance, in distance units, currently set for the 
//              sound buffer. 
//              
//              The default minimum distance is defined in the dsound.h 
//              DS3D_DEFAULTMINDISTANCE member as 1.0. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pMinDistance - 
//                The MinDistance parameter will reference the current minimum 
//                distance set for the sound buffer if this method returns 
//                successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::GetMinDistance( D3DVALUE* pMinDistance )
{
// Original Function Definition
// HRESULT GetMinDistance( 
//   LPD3DVALUE lpflMinDistance   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetMinDistance()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pMinDistance==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetMinDistance()", "TDX_BADPARAMS", "'pMinDistance' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->GetMinDistance( (LPD3DVALUE) pMinDistance );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetMinDistance()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetMode()
// Description: The TDx_Sound3DBuffer::GetMode method will return the current 
//              mode of 3D sound processing operation. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pMode - 
//                The Mode parameter will reference flags indicating the 
//                current mode setting if this method returns successfully. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3DMODE_DISABLE -
//                    There is no 3D sound processing. 
//                    Sounds will appear to originate from the center of the 
//                    listeners head. 
//                  DS3DMODE_HEADRELATIVE -
//                    The 3D sound properties are relative to the properties 
//                    of the listener. 
//                    Absolute sound properties will be updated automatically 
//                    as the listener's properties change, maintaining 
//                    constant relative propeties as a result. 
//                  DS3DMODE_NORMAL -
//                    The 3D sounds are processed normally. 
//                    This is the default. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::GetMode( dword* pMode )
{
// Original Function Definition
// HRESULT GetMode( 
//   LPDWORD lpdwMode   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetMode()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pMode==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetMode()", "TDX_BADPARAMS", "'pMode' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->GetMode( (LPDWORD) pMode );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetMode()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetPosition()
// Description: The TDx_Sound3DBuffer::GetPosition method will retrieve the 
//              current position, in distance units, of this sound buffer in 
//              3D space. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pPosition - 
//                The Position parameter references a D3DVECTOR for holding the 
//                current position of the sound buffer if this method returns 
//                successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::GetPosition( D3DVECTOR* pPosition )
{
// Original Function Definition
// HRESULT GetPosition( 
//   LPD3DVECTOR lpvPosition   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetPosition()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pPosition==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetPosition()", "TDX_BADPARAMS", "'pPosition' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->GetPosition( (LPD3DVECTOR) pPosition );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetPosition()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetVelocity()
// Description: The TDx_Sound3DBuffer::GetVelocity method will return the 
//              velocity, in distance units per second, currently set for 
//              this sound buffer. 
//              
//              This value is used to calculate doppler effects only, it is 
//              up to the application to move the buffer appropriately. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pVelocity - 
//                The Velocity parameter references a D3DVECTOR for holding the 
//                current velocity of the sound buffer if this method returns 
//                successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::GetVelocity( D3DVECTOR* pVelocity )
{
// Original Function Definition
// HRESULT GetVelocity( 
//   LPD3DVECTOR lpvVelocity   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetVelocity()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pVelocity==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetVelocity()", "TDX_BADPARAMS", "'pVelocity' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->GetVelocity( (LPD3DVECTOR) pVelocity );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetVelocity()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetAllParameters()
// Description: The TDx_Sound3DBuffer::SetAllParameters method will set all 
//              the properties of the sound buffer to the specified values. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              TDX_BADPARAMS 
//              DSERR_INVALIDPARAM 
// Params:      pBuffer - 
//                The Buffer parameter references a TDS3DBuffer component 
//                holding information which describes the 3D characteristics 
//                that are to be applied to this sound buffer. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                settings should be applied immediately. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until 
//                    TDx_Sound3DListener::CommitDeferredSettings() is called 
//                    before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::SetAllParameters( TDS3DBuffer* pBuffer, dword pApply )
{
// Original Function Definition
// HRESULT SetAllParameters( 
//   LPCDS3DBUFFER lpcDs3dBuffer,   
//   DWORD dwApply                 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetAllParameters()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pBuffer==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::SetAllParameters()", "TDX_BADPARAMS", "'pBuffer' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->SetAllParameters( pBuffer->Internal_DS3DBUFFER_Ptr, (DWORD) pApply );

// Translate Data returned from Function
pBuffer->Internal_DS3DBUFFER_Update();

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetAllParameters()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetConeAngles()
// Description: The TDx_Sound3DBuffer::SetConeAngles method will set the 
//              inside and outside sound projection cone angles of the sound 
//              buffer. 
//              
//              The minimum, maximum and default cone angles are defined in 
//              the dsound.h DS3D_MINCONEANGLE, DS3D_MAXCONEANGLE and 
//              DS3D_DEFAULTCONEANGLE members as 0, 360 and 360 degrees 
//              respectively. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pInsideConeAngle - 
//                The InsideConeAngle parameter defines the angle, in degrees, 
//                to which the inside sound projection cone is to be set. 
//              pOutsideConeAngle - 
//                The OutsideConeAngle parameter defines the angle, in degrees, 
//                to which the outside sound projection cone is to be set. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied immediately. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until 
//                    TDx_Sound3DListener::CommitDeferredSettings() is called 
//                    before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::SetConeAngles( dword pInsideConeAngle, dword pOutsideConeAngle, dword pApply )
{
// Original Function Definition
// HRESULT SetConeAngles( 
//   DWORD dwInsideConeAngle,   
//   DWORD dwOutsideConeAngle,   
//   DWORD dwApply             
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetConeAngles()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->SetConeAngles( (DWORD) pInsideConeAngle, (DWORD) pOutsideConeAngle, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetConeAngles()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetConeOrientation()
// Description: The TDx_Sound3DBuffer::SetConeOrientation method will set the 
//              sound projection cone orientation for this sound buffer. 
//              
//              Cone angles and volume factors must also have been set for 
//              this method to have any effect. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pX - 
//                The X parameter defines a D3DVALUE representing the new X 
//                coordinate of the sound cone orientation vector. 
//              pY - 
//                The Y parameter defines a D3DVALUE representing the new Y 
//                coordinate of the sound cone orientation vector. 
//              pZ - 
//                The Z parameter defines a D3DVALUE representing the new Z 
//                coordinate of the sound cone orientation vector. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied immediately. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until 
//                    TDx_Sound3DListener::CommitDeferredSettings() is called 
//                    before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::SetConeOrientation( D3DVALUE pX, D3DVALUE pY, D3DVALUE pZ, dword pApply )
{
// Original Function Definition
// HRESULT SetConeOrientation( 
//   D3DVALUE x,     
//   D3DVALUE y,     
//   D3DVALUE z,     
//   DWORD dwApply   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetConeOrientation()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->SetConeOrientation( pX, pY, pZ, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetConeOrientation()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetConeOutsideVolume()
// Description: The TDx_Sound3DBuffer::SetConeOutsideVolume method will set 
//              the volume, in 100ths of a decibel, for the outside cone of 
//              the sound buffer. 
//              
//              This volume is expressed as an attenuation value and is 
//              subtracted from the normal volume levels. 
//              
//              The minimum, maximum and default cone outside volumes are 
//              defined in the dsound.h DSBVOLUME_MIN, DSBVOLUME_MAX and 
//              DS3D_DEFAULTCONEOUTSIDEVOLUME members as -10000, 0 and 0 
//              respectively. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pConeOutsideVolume - 
//                The ConeOutsideVolume parameter defines the volume, in 100ths 
//                of a decibel, to which the outside cone of the sound buffer 
//                is to be set. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied immediately. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until 
//                    TDx_Sound3DListener::CommitDeferredSettings() is called 
//                    before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::SetConeOutsideVolume( long pConeOutsideVolume, dword pApply )
{
// Original Function Definition
// HRESULT SetConeOutsideVolume( 
//   LONG lConeOutsideVolume,   
//   DWORD dwApply             
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetConeOutsideVolume()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->SetConeOutsideVolume( (LONG) pConeOutsideVolume, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetConeOutsideVolume()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetMaxDistance()
// Description: The TDx_Sound3DBuffer::SetMaxDistance method will set the 
//              maximum distance, in distance units, for the sound buffer. 
//              
//              The default maximum distance is defined in the dsound.h 
//              DS3D_DEFAULTMAXDISTANCE member as 1000000000.0 and as such 
//              can be regarded as effectively infinite. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pMaxDistance - 
//                The MaxDistance parameter defines the maximum distance value 
//                to be set for the sound buffer. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied immediately. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until 
//                    TDx_Sound3DListener::CommitDeferredSettings() is called 
//                    before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::SetMaxDistance( D3DVALUE pMaxDistance, dword pApply )
{
// Original Function Definition
// HRESULT SetMaxDistance( 
//   D3DVALUE flMaxDistance,   
//   DWORD dwApply             
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetMaxDistance()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->SetMaxDistance( pMaxDistance, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetMaxDistance()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetMinDistance()
// Description: The TDx_Sound3DBuffer::SetMinDistance method will set the 
//              minimum distance, in distance units, for the sound buffer. 
//              
//              The default minimum distance is defined in the dsound.h 
//              DS3D_DEFAULTMINDISTANCE member as 1.0. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pMinDistance - 
//                The MinDistance parameter defines the minimum distance value 
//                to be set for the sound buffer. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied immediately. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until 
//                    TDx_Sound3DListener::CommitDeferredSettings() is called 
//                    before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::SetMinDistance( D3DVALUE pMinDistance, dword pApply )
{
// Original Function Definition
// HRESULT SetMinDistance( 
//   D3DVALUE flMinDistance,   
//   DWORD dwApply             
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetMinDistance()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->SetMinDistance( pMinDistance, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetMinDistance()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetMode()
// Description: The TDx_Sound3DBuffer::SetMode method will set the mode of 3D 
//              sound processing operations for this buffer. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pMode - 
//                The Mode parameter defines flags indicating the 3D processing 
//                mode to be set for the sound buffer. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3DMODE_DISABLE -
//                    There is to be no 3D sound processing. 
//                    Sounds will appear to originate from the center of the 
//                    users head. 
//                  DS3DMODE_HEADRELATIVE -
//                    The 3D sound properties are to be relative to the 
//                    properties of the listener. 
//                    Absolute sound properties will be updated automatically 
//                    as the listener's properties change, maintaining 
//                    constant relative propeties as a result. 
//                  DS3DMODE_NORMAL -
//                    3D sounds are to be processed normally. 
//                    This is the default setting. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied immediately. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until 
//                    TDx_Sound3DListener::CommitDeferredSettings() is called 
//                    before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::SetMode( dword pMode, dword pApply )
{
// Original Function Definition
// HRESULT SetMode( 
//   DWORD dwMode,   
//   DWORD dwApply   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetMode()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->SetMode( (DWORD) pMode, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetMode()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetPosition()
// Description: The TDx_Sound3DBuffer::SetPosition method will set the 
//              position, in distance units, of this sound buffer in 3D 
//              space. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pX - 
//                The X parameter defines a D3DVALUE representing the new X 
//                coordinate of the sound buffer in 3D space. 
//                This value may be adjusted to prevent floating point 
//                overflow. 
//              pY - 
//                The Y parameter defines a D3DVALUE representing the new Y 
//                coordinate of the sound buffer in 3D space. 
//                This value may be adjusted to prevent floating point 
//                overflow. 
//              pZ - 
//                The Z parameter defines a D3DVALUE representing the new Z 
//                coordinate of the sound buffer in 3D space. 
//                This value may be adjusted to prevent floating point 
//                overflow. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied immediately. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until 
//                    TDx_Sound3DListener::CommitDeferredSettings() is called 
//                    before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::SetPosition( D3DVALUE pX, D3DVALUE pY, D3DVALUE pZ, dword pApply )
{
// Original Function Definition
// HRESULT SetPosition( 
//   D3DVALUE x,     
//   D3DVALUE y,     
//   D3DVALUE z,     
//   DWORD dwApply   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetPosition()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->SetPosition( pX, pY, pZ, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetPosition()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetVelocity()
// Description: The TDx_Sound3DBuffer::SetVelocity method will set the 
//              velocity, in distance units per second, for the sound buffer. 
//              
//              This value is only used to calculate doppler effects, it is 
//              up to the application to move the buffer appropriately. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pX - 
//                The X parameter defines a D3DVALUE representing the new X 
//                coordinate of the velocity vector for the sound buffer. 
//                This value may be adjusted to prevent floating-point 
//                overflow. 
//              pY - 
//                The Y parameter defines a D3DVALUE representing the new Y 
//                coordinate of the velocity vector for the sound buffer. 
//                This value may be adjusted to prevent floating-point 
//                overflow. 
//              pZ - 
//                The Z parameter defines a D3DVALUE representing the new Z 
//                coordinate of the velocity vector for the sound buffer. 
//                This value may be adjusted to prevent floating-point 
//                overflow. 
//              pApply - 
//                The Apply parameter defines flags indicating whether the 
//                setting should be applied immediately. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DS3D_DEFERRED -
//                    Wait until 
//                    TDx_Sound3DListener::CommitDeferredSettings() is called 
//                    before committing the settings. 
//                    This allows several changes to be made before 
//                    recalculating. 
//                  DS3D_IMMEDIATE -
//                    Apply the settings immediately. 
//                    The 3D coordinates of all 3D sound buffers will be 
//                    recalculated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_Sound3DBuffer::SetVelocity( D3DVALUE pX, D3DVALUE pY, D3DVALUE pZ, dword pApply )
{
// Original Function Definition
// HRESULT SetVelocity( 
//   D3DVALUE x,     
//   D3DVALUE y,     
//   D3DVALUE z,     
//   DWORD dwApply   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetVelocity()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUND3DBUFFER->SetVelocity( pX, pY, pZ, (DWORD) pApply );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetVelocity()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Internal Interface Access
// --------------------------------------------------------------------------
LPDIRECTSOUND3DBUFFER __fastcall TDx_Sound3DBuffer::FGetInternal_LPDIRECTSOUND3DBUFFER()
{
return fLPDIRECTSOUND3DBUFFER;
}
// --------------------------------------------------------------------------
LPDIRECTSOUND3DBUFFER* __fastcall TDx_Sound3DBuffer::FGetInternal_LPDIRECTSOUND3DBUFFER_Ptr()
{
return &fLPDIRECTSOUND3DBUFFER;
}
// --------------------------------------------------------------------------
void __fastcall TDx_Sound3DBuffer::FSetInternal_LPDIRECTSOUND3DBUFFER( LPDIRECTSOUND3DBUFFER pLPDIRECTSOUND3DBUFFER )
{
if (!fCreated)
    {
    fLPDIRECTSOUND3DBUFFER = pLPDIRECTSOUND3DBUFFER;
    fCreated = (fLPDIRECTSOUND3DBUFFER!=NULL);
    }
}
// --------------------------------------------------------------------------
void __fastcall TDx_Sound3DBuffer::Internal_LPDIRECTSOUND3DBUFFER_Update()
{
fCreated = (fLPDIRECTSOUND3DBUFFER!=NULL);
}

// --------------------------------------------------------------------------
