// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDx_SoundCaptureBuffer.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               
// Description:  This file contains the code for the TDx_SoundCaptureBuffer 
//               Component 
//
// "TDx_Sound_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDx_SoundCaptureBuffer.H"
// --------------------------------------------------------------------------
// external classes used by the TDx_SoundCaptureBuffer component.
#include "TDx_SoundCapture.H"
// --------------------------------------------------------------------------
// external classes used by TDx_SoundCaptureBuffer methods.
#include "TDSCBufferDesc.H"
#include "TDSCBCaps.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Sound_Library_Defns"
#pragma link "TDx_Sound_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDx_SoundCaptureBuffer*)
{
    new TDx_SoundCaptureBuffer(NULL);
}
// --------------------------------------------------------------------------
namespace Tdx_soundcapturebuffer
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDx_SoundCaptureBuffer)};
        RegisterComponents("TDx_Sound", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDx_SoundCaptureBuffer::TDx_SoundCaptureBuffer()
// Description: The default constructor for the TDx_SoundCaptureBuffer object.
// --------------------------------------------------------------------------
__fastcall TDx_SoundCaptureBuffer::TDx_SoundCaptureBuffer(TComponent* Owner)
    : TComponent(Owner)
{
fCreated = false;
fErrorValue = DS_OK;
fStreamFormat = NULL;
fStreamHandle = -1;
fStreamIsOpen = false;
fStreamSize = 0;
}
// --------------------------------------------------------------------------
// Destructor:  TDx_SoundCaptureBuffer::~TDx_SoundCaptureBuffer()
// Description: The destructor for the TDx_SoundCaptureBuffer object.
// --------------------------------------------------------------------------
__fastcall TDx_SoundCaptureBuffer::~TDx_SoundCaptureBuffer()
{
// destroy internals
if (Created) Destroy();
if (fStreamFormat!=NULL) GlobalFree( fStreamFormat );
if (fStreamHandle!=-1) close( fStreamHandle );
}
// --------------------------------------------------------------------------
// Property:    Created
// Description: The Created property is true if the internal 
//              LPDIRECTSOUNDCAPTUREBUFFER used in this component has been 
//              successfully created, otherwise Created is false. 
//              
//              To create the internal LPDIRECTSOUNDCAPTUREBUFFER, call the 
//              TDx_SoundCaptureBuffer::Create() method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::FGetCreated()
{
return fCreated;
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundCaptureBuffer::FSetCreated( bool pCreated )
{
fCreated = (pCreated && (fLPDIRECTSOUNDCAPTUREBUFFER==NULL));
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDx_SoundCaptureBuffer method or 
//              fget/fset. eg. DS_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDx_SoundCaptureBuffer::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundCaptureBuffer::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Recording
// Description: The Recording property can be used to determine whether or 
//              not a capture buffer is currently recording. If true, the 
//              capture buffer is currently recording. If false, the capture 
//              buffer is not currently recording. 
//              
//              This is equivalent to calling 
//              TDx_SoundCaptureBuffer::GetStatus() and checking for 
//              DSCBSTATUS_CAPTURING. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::FGetRecording()
{
dword status;
if (GetStatus( &status ))
    if ((status & DSCBSTATUS_CAPTURING)==DSCBSTATUS_CAPTURING) return true;
return false;
}
// --------------------------------------------------------------------------
// Property:    StreamFormat
// Description: The StreamFormat property references an internal WAVEFORMATEX 
//              structure defining the format of the current stream. 
//              This property is set during a call to either 
//              TDx_SoundCaptureBuffer::CreateStream() or 
//              TDx_SoundCaptureBuffer::SaveToFile() based on the 
//              user-supplied WAVEFORMATEX structure. 
// --------------------------------------------------------------------------
WAVEFORMATEX* __fastcall TDx_SoundCaptureBuffer::FGetStreamFormat()
{
return fStreamFormat;
}
// --------------------------------------------------------------------------
// Property:    StreamHandle
// Description: The StreamHandle property is used internally by the 
//              TDx_SoundCaptureBuffer component to implement sound 
//              streaming. 
// --------------------------------------------------------------------------
int __fastcall TDx_SoundCaptureBuffer::FGetStreamHandle()
{
return fStreamHandle;
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundCaptureBuffer::FSetStreamHandle( int pStreamHandle )
{
fStreamHandle = pStreamHandle;
}
// --------------------------------------------------------------------------
// Property:    StreamIsOpen
// Description: The StreamIsOpen property will be set to true if a stream is 
//              currently open and false otherwise. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::FGetStreamIsOpen()
{
return fStreamIsOpen;
}
// --------------------------------------------------------------------------
// Property:    StreamSize
// Description: The StreamSize property holds the total number of bytes in 
//              the current stream. 
//              Set this property to the total size of the stream to be 
//              saved, in bytes, before calling 
//              TDx_SoundCatureBuffer::SaveToFile(). 
//              
//              After calling TDx_SoundCaptureBuffer::CreateFromStream(), 
//              this property will contain the total number of bytes of data 
//              read from the stream. 
//              After calling TDx_SoundCaptureBuffer::CreateStream() or 
//              TDx_SoundCaptureBuffer::OpenStream() this property will be 0. 
//              After calling TDx_SoundCaptureBuffer::CloseStream() this 
//              property will contain the total number of bytes read from or 
//              written to the stream using 
//              TDx_SoundCaptureBuffer::ReadFromStream() or 
//              TDx_SoundBuffer::WriteToStream() since the last call to 
//              TDx_SoundCaptureBuffer::CreateStream() 
//              After calling TDx_SoundCaptureBuffer::CreateStream() this 
//              property will contain the total number of bytes read from or 
//              written to the stream. 
// --------------------------------------------------------------------------
dword __fastcall TDx_SoundCaptureBuffer::FGetStreamSize()
{
return fStreamSize;
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundCaptureBuffer::FSetStreamSize( dword pStreamSize )
{
fStreamSize = pStreamSize;
}
// --------------------------------------------------------------------------
// Property:    WaveFileFormat
// Description: The WaveFileFormat property is used internally to setup the 
//              .WAV file header for streaming. 
// --------------------------------------------------------------------------
TDX_WAVE_FILE_FORMAT __fastcall TDx_SoundCaptureBuffer::FGetWaveFileFormat()
{
return fWaveFileFormat;
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundCaptureBuffer::FSetWaveFileFormat( TDX_WAVE_FILE_FORMAT pWaveFileFormat )
{
fWaveFileFormat = pWaveFileFormat;
}
// --------------------------------------------------------------------------
// Method:      CloseStream()
// Description: The CloseStream method will close the current .wav file. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              TDX_ERROR 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::CloseStream()
{
if (fStreamFormat==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, Name+"::CloseStream()", "TDX_ERROR", "StreamFormat is NULL when it should not be NULL." );
    return false;
    }

if (!fStreamIsOpen)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, Name+"::CloseStream()", "TDX_ERROR", "Cannot close the stream because it is not open." );
    return false;
    }

// update the wave file header
fWaveFileFormat.data_chunk.size = fStreamSize;
fWaveFileFormat.riff_chunk.size = sizeof( TDX_WAVE_FILE_FORMAT ) + fStreamSize - 8;

// write it to the file
int error = lseek( fStreamHandle, 0, SEEK_SET );
if (error==-1)
    {
    close( fStreamHandle );
    fStreamHandle = NULL;
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, Name+"::CloseStream()", "TDX_ERROR", "Cannot create the stream because could not seek to update the file header." );
    return false;
    }
error = write( fStreamHandle, (void*) &fWaveFileFormat, sizeof(fWaveFileFormat) );
if (error==-1)
    {
    close( fStreamHandle );
    fStreamHandle = NULL;
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, Name+"::CloseStream()", "TDX_ERROR", "Cannot create the stream because the wave file header could not be created." );
    return false;
    }

// close the file
close( fStreamHandle );
delete[] fStreamFormat;
fStreamFormat = NULL;
fStreamHandle = -1;
fStreamIsOpen = false;
fErrorValue = DS_OK;
return true;
}

// --------------------------------------------------------------------------
// Method:      Create()
// Description: The Create() method is used to automatically create the 
//              internal LPDIRECTSOUNDCAPTUREBUFFER interface used in the 
//              TDx_SoundCaptureBuffer component and must be called before 
//              any methods of the TDx_SoundCaptureBuffer component will 
//              function. 
// Params:      pCaptureBufferDesc - 
//                The CaptureBufferDesc parameter references a TDSBufferDesc 
//                defining the properties of the capture buffer being created. 
//              pSoundCapture - 
//                The SoundCapture parameter references the existing 
//                TDx_SoundCapture component for which the sound buffer is to 
//                be created. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::Create( TDSCBufferDesc* pCaptureBufferDesc, TDx_SoundCapture* pSoundCapture )
{
// if the component internals have already been created, exit
if (fCreated)
    {
    fErrorValue = TDX_ALREADYCREATED;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ALREADYCREATED", "The "+Name+"::Create() method was called when the component has already been created successfully." );
    return false;
    }

// check params for accuracy
if (pCaptureBufferDesc==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_BADPARAMS", "The 'pCaptureBufferDesc' parameter must point to an existing TDSCBufferDesc component and cannot be NULL." );
    return false;
    }
if (pSoundCapture==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_BADPARAMS", "The 'pSoundCapture' parameter must point to an existing TDx_SoundCapture component and cannot be NULL." );
    return false;
    }

// code that creates the internal IDirectSoundCaptureBuffer interface
pSoundCapture->CreateCaptureBuffer( pCaptureBufferDesc, this );
fErrorValue = pSoundCapture->ErrorValue;

if (fErrorValue!=DS_OK)
    {
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", "The "+Name+"::Create() method failed because "+pSoundCapture->Name+"::CreateCaptureBuffer() failed with error: "+TDx_Sound_Library_ErrorString(fErrorValue)+", "+TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// successfully created
fCreated = true;
if (FOnCreate) FOnCreate(this);
return true;
}

// --------------------------------------------------------------------------
// Method:      CreateStream()
// Description: The CreateStream method will create a new .wav file using the 
//              format of the WAVEFORMATEX structure supplied. 
//              
//              If the file already exists, it is replaced. 
//              If the file does not exist, it will be created if possible. 
//              If the file cannot be created, the file remnants will remain. 
//              
//              If the method call is successful, the method returns true, 
//              and the TDx_SoundCaptureBuffer::StreamIsOpen property is 
//              true. 
//              When open for streaming, raw sound data to the stream using 
//              the TDx_SoundCaptureBuffer::WriteToStream() method. 
//              When finished streaming, you can close the stream using the 
//              TDx_SoundCaptureBuffer::CloseStream() method. 
//              
//              If the method call fails, the method returns false, and the 
//              OnError event will be triggered with one of the following 
//              values: 
//              
//                TDX_BADPARAMS 
//                TDX_ERROR 
// Params:      pFileName - 
//                The FileName parameter defines the path and filename of the 
//                 .wav file to be created. 
//              pFormat - 
//                The Format method parameter describes the format of the sound 
//                file to be created. This parameter must point to a 
//                user-supplied WAVEFORMATEX structure that has been filled 
//                with appropriate values. 
//                
//                You can retrieve the WAVEFORMATEX of the current buffer using 
//                the TDx_SoundCaptureBuffer::GetFormat()  method. 
//                
//                You can also pass in a non-WAVE_FORMAT_PCM structure typecast 
//                as a WAVEFORMATEX, and supply the byte-size of the 
//                non-WAVE_FORMAT_PCM using the FormatSize parameter. 
//              pFormatSize - 
//                The FormatSize parameter must contain the size of the 
//                WAVEFORMATEX structure passed into this method via the Format 
//                parameter. Generally this will be sizeof(WAVEFORMATEX) but it 
//                may differ depending on the definition of the WAVEFORMATEX.. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::CreateStream( AnsiString pFileName, WAVEFORMATEX* pFormat, int pFormatSize )
{
// check 'filename' parameter
if (pFileName=="")
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError(this, Name+"::CreateStream()", "TDX_BADPARAMS", "The 'FileName' parameter cannot be a NULL string." );
    return false;
    }
if (pFileName.UpperCase().Pos(".WAV")==0) pFileName = pFileName +".WAV";

// check 'format' parameter
if (pFormat==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError(this, Name+"::CreateStream()", "TDX_BADPARAMS", "The 'Format' parameter must reference a valid WAVEFORMATEX structure and cannot be NULL." );
    return false;
    }
if (pFormatSize<sizeof(WAVEFORMATEX))
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError(this, Name+"::CreateStream()", "TDX_BADPARAMS", "The 'FormatSize' parameter is "+IntToStr(pFormatSize)+" but must be at least sizeof(WAVEFORMATEX)." );
    return false;
    }

// cleanup ready to open the stream
if (StreamIsOpen) CloseStream();

// open the stream
fStreamHandle = open( pFileName.c_str(), O_CREAT | O_TRUNC | O_BINARY | O_RDWR, S_IREAD|S_IWRITE );
if (fStreamHandle==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, Name+"::CreateStream()", "TDX_ERROR", "Cannot create a new media file: "+pFileName+"." );
    return false;
    }

// allocate memory for the internal format
fStreamFormat = (WAVEFORMATEX*) new byte[ pFormatSize ];
if (fStreamFormat==NULL)
    {
    close( fStreamHandle );
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, Name+"::CreateStream()", "TDX_ERROR", "Cannot allocate memory for internal storage of the WAVEFORMATEX structure passed in via the 'Format' parameter." );
    return false;
    }

// copy the format supplied into internal storage
CopyMemory( fStreamFormat, pFormat, pFormatSize );

// setup the wave file header
fWaveFileFormat = DEFAULT_TDX_WAVE_FILE_FORMAT;
CopyMemory( (void*) &fWaveFileFormat.format_chunk.format, pFormat, sizeof(TDX_WAVE_FORMAT) );
fWaveFileFormat.data_chunk.size = 0;

// write it to the file
int error = write( fStreamHandle, (void*) &fWaveFileFormat, sizeof(TDX_WAVE_FILE_FORMAT) );
if (error==-1)
    {
    close( fStreamHandle );
    fStreamHandle = NULL;
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, Name+"::CreateStream()", "TDX_ERROR", "Cannot create the media file: "+pFileName+" because the Wave File Format could not be created." );
    return false;
    }

// if there is extra PCM data at the end of the file format, write it to the file too
if (pFormatSize > sizeof(WAVEFORMATEX))
    {
    int error = write( fStreamHandle, (void*) &pFormat[ sizeof(WAVEFORMATEX) ], sizeof(WAVEFORMATEX) - pFormatSize );
    if (error==-1)
        {
        close( fStreamHandle );
        fStreamHandle = NULL;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, Name+"::CreateStream()", "TDX_ERROR", "Cannot create the media file: "+pFileName+" because the Extra PCM Info could not be created." );
        return false;
        }
    }

// successfully created the stream
fStreamSize = 0;
fStreamIsOpen = true;
fErrorValue = DS_OK;
return true;
}

// --------------------------------------------------------------------------
// Method:      Destroy()
// Description: The Destroy() method is used to automatically destroy the 
//              internal LPDIRECTSOUNDCAPTUREBUFFER interface used in the 
//              TDx_SoundCaptureBuffer component and should be called when 
//              the internal interface is no longer required. 
//              
//              Note: This method is called by the component's destructor. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::Destroy()
{
// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_NOTCREATED", "The "+Name+"::Destroy() method was called before being created successfully." );
    return false;
    }

// if the stream is still open, close it now.
if (fStreamIsOpen) CloseStream();

// code that destroys the internal interface
if (FOnDestroy) FOnDestroy(this);

if (fLPDIRECTSOUNDCAPTUREBUFFER==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "The "+Name+" component's internal LPDIRECTSOUNDCAPTUREBUFFER is NULL but the TDx_Sound component is expecting it to be not NULL. Aborting the Destroy()." );
    return false;
    }

try { 
    fLPDIRECTSOUNDCAPTUREBUFFER->Release(); 
    } 
catch (...) 
    { 
    fErrorValue = TDX_ERROR; 
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "An exception has occurred within LPDIRECTSOUNDCAPTUREBUFFER->Release(). Check that you are destroying all components in reverse order of creation." );
    }

// successful destruction
fLPDIRECTSOUNDCAPTUREBUFFER = NULL;
fCreated = false;
return true;
}

// --------------------------------------------------------------------------
// Method:      GetCaps()
// Description: The TDx_SoundCaptureBuffer::GetCaps method will return the 
//              capture buffer's capabilities. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DSERR_INVALIDPARAM 
//              DSERR_UNSUPPORTED 
//              DSERR_OUTOFMEMORY 
// Params:      pCBCaps - 
//                The CBCaps parameter references a TDSCBCaps component for 
//                holding the capture buffer capabilities if this method 
//                returns successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::GetCaps( TDSCBCaps* pCBCaps )
{
// Original Function Definition
// HRESULT GetCaps( 
//   LPDSCBCAPS lpDSCBCaps   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetCaps()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pCBCaps==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetCaps()", "TDX_BADPARAMS", "'pCBCaps' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUNDCAPTUREBUFFER->GetCaps( pCBCaps->Internal_DSCBCAPS_Ptr );

// Translate Data returned from Function
pCBCaps->Internal_DSCBCAPS_Update();

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetCaps()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetCurrentPosition()
// Description: The TDx_SoundCaptureBuffer::GetCurrentPosition method will 
//              return the current position of the capture and read pointers 
//              within the buffer. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DSERR_INVALIDPARAM 
//              DSERR_NODRIVER 
//              DSERR_OUTOFMEMORY 
// Params:      pCapturePosition - 
//                The CapturePosition parameter will reference the offset of 
//                the capture cursor within the capture buffer if this method 
//                returns successfully. 
//                
//                Set this parameter to NULL if the capture cursor position is 
//                not required. 
//              pReadPosition - 
//                The ReadPosition parameter will reference the offset of the 
//                read cursor within the capture buffer if this method returns 
//                successfully. 
//                
//                Set this parameter to NULL if the read cursor position is not 
//                required. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::GetCurrentPosition( dword* pCapturePosition, dword* pReadPosition )
{
// Original Function Definition
// HRESULT GetCurrentPosition( 
//   LPDWORD lpdwCapturePosition,   
//   LPDWORD lpdwReadPosition   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetCurrentPosition()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUNDCAPTUREBUFFER->GetCurrentPosition( (LPDWORD) pCapturePosition, (LPDWORD) pReadPosition );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetCurrentPosition()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetFormat()
// Description: The TDx_SoundCaptureBuffer::GetFormat method will return the 
//              sound format currently set for the capture buffer. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pFormat - 
//                The Format parameter references a WAVEFORMATEX structure for 
//                holding the sound data format of the capture buffer if this 
//                method returns successfully. 
//                
//                Setting this parameter to NULL will cause the buffer size 
//                needed to be retrieved and placed in the SizeWritten 
//                parameter of this method. 
//              pSizeAllocated - 
//                The SizeAllocated parameter defines the size, in bytes, of 
//                the WAVEFORMATEX structure referenced by the Format parameter 
//                of this method. 
//                If the structure exceeds this value it will be truncated. 
//              pSizeWritten - 
//                The SizeWritten parameter will reference the amount, in 
//                bytes, that was written into the WAVEFORMATEX structure 
//                referenced by the Format parameter if this method returns 
//                successfully. 
//                
//                This parameter may be set to NULL. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::GetFormat( WAVEFORMATEX* pFormat, dword pSizeAllocated, dword* pSizeWritten )
{
// Original Function Definition
// HRESULT GetFormat( 
//   LPWAVEFORMATEX lpwfxFormat,   
//   DWORD dwSizeAllocated,   
//   LPDWORD lpdwSizeWritten   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetFormat()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pFormat==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetFormat()", "TDX_BADPARAMS", "'pFormat' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUNDCAPTUREBUFFER->GetFormat( (LPWAVEFORMATEX) pFormat, (DWORD) pSizeAllocated, (LPDWORD) pSizeWritten );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetFormat()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetStatus()
// Description: The TDx_SoundCaptureBuffer::GetStatus method will return the 
//              current status of the capture buffer. 
//              
//              If the method call fails, the OnError event may be triggered 
//              with the following value: 
//              DSERR_INVALIDPARAM 
// Params:      pStatus - 
//                The Status parameter references flags indicating the current 
//                status of the capture buffer. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DSBSTATUS_LOOPING -
//                    The buffer is looping. 
//                    The buffer returns to the beginning and continues 
//                    capturing when it reaches the end of the buffer. When 
//                    this flag is set, the buffer will also be capturing. 
//                  DSCBSTATUS_CAPTURING -
//                    The buffer is currently capturing. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::GetStatus( dword* pStatus )
{
// Original Function Definition
// HRESULT GetStatus( 
//   DWORD* lpdwStatus   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetStatus()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pStatus==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetStatus()", "TDX_BADPARAMS", "'pStatus' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUNDCAPTUREBUFFER->GetStatus( (DWORD*) pStatus );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetStatus()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      Lock()
// Description: The TDx_SoundCaptureBuffer::Lock method will return pointers 
//              into the capture buffer, allowing the reading or writing of 
//              audio data. 
//              
//              The capture buffer should not be locked for long periods as 
//              the capture cursor will reach the locked bytes cause 
//              configuration dependent audio problems. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DSERR_INVALIDPARAM 
//              DSERR_INVALIDCALL 
// Params:      pReadCursor - 
//                The ReadCursor parameter defines the offset, in bytes, to 
//                where the lock is to begin in the buffer. 
//              pReadBytes - 
//                The ReadBytes parameter defines the amount, in bytes, of the 
//                buffer that is to be locked. 
//                
//                The space that is locked may wrap around to the start of the 
//                buffer, which is conceptually circular, in which case the 
//                AudioPtr2 parameter of this method will reference the start 
//                of the buffer. 
//                
//                Setting DSCBLOCK_ENTIREBUFFER in the Flags parameter of this 
//                method will cause this parameter to be ignored. 
//              pAudioPtr1 - 
//                The AudioPtr1 parameter will reference the first block of 
//                locked capture buffer if this method returns successfully. 
//              pAudioBytes1 - 
//                The AudioBytes1 parameter references the number of bytes 
//                referenced by the AudioPtr1 parameter of this method. 
//                
//                When this value is less than the value in the ReadBytes 
//                parameter of this method, it means AudioPtr2 will reference a 
//                second block of sound data. 
//              pAudioPtr2 - 
//                The AudioPtr2 parameter will reference the second block of 
//                locked capture buffer if this method returns successfully. 
//                
//                When this parameter is NULL it means AudioPtr1 references the 
//                entire locked region of the sound buffer and any portion of 
//                the area that wraps around will not be locked. 
//              pAudioBytes2 - 
//                The AudioBytes2 parameter references the number of bytes 
//                referenced by the AudioPtr2 parameter of this method. 
//                
//                When the AudioPtr2 parameter of this method is set to NULL, 
//                this parameter will be 0. 
//              pFlags - 
//                The Flags parameter defines a flag modifying the lock event. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DSBLOCK_ENTIREBUFFER -
//                    Lock the whole capture buffer. 
//                    Setting this flag causes the ReadBytes parameter of 
//                    this method to be ignored. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::Lock( dword pReadCursor, dword pReadBytes, void** pAudioPtr1, dword* pAudioBytes1, void** pAudioPtr2, dword* pAudioBytes2, dword pFlags )
{
// Original Function Definition
// HRESULT Lock( 
//   DWORD dwReadCursor,       
//   DWORD dwReadBytes,       
//   LPVOID* lplpvAudioPtr1,   
//   LPDWORD lpdwAudioBytes1,   
//   LPVOID* lplpvAudioPtr2,   
//   LPDWORD lpdwAudioBytes2,   
//   DWORD dwFlags             
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Lock()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pAudioPtr1==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Lock()", "TDX_BADPARAMS", "'pAudioPtr1' cannot be 'NULL'");
    return false;
    }
if (pAudioBytes1==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Lock()", "TDX_BADPARAMS", "'pAudioBytes1' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUNDCAPTUREBUFFER->Lock( (DWORD) pReadCursor, (DWORD) pReadBytes, (LPVOID*) pAudioPtr1, (LPDWORD) pAudioBytes1, (LPVOID*) pAudioPtr2, (LPDWORD) pAudioBytes2, (DWORD) pFlags );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::Lock()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SaveToFile()
// Description: The SaveToFile ()method will save the entire sound buffer to 
//              a specified .WAV file. 
//              Calling this method is equivalent to calling the following 
//              methods in the order shown here :- 
//              
//                TDx_SoundCaptureBuffer::CreateStream() 
//                TDx_SoundCaptureBuffer::Lock() 
//                TDx_SoundCaptureBuffer::WriteToStream() 
//                TDx_SoundCaptureBuffer::Unlock() 
//                TDx_SoundCaptureBuffer::CloseStream() 
//              
//              If the file already exists, it is replaced. 
//              If the file does not exist, it will be created if possible. 
//              If the file cannot be created, the file remnants will remain. 
//              
//              If you wish to save multiple chunks of sound data,  do this 
//              :- 
//              
//                TDx_SoundCaptureBuffer::CreateStream() 
//                TDx_SoundCaptureBuffer::Lock() 
//                TDx_SoundCaptureBuffer::WriteToStream() 
//                TDx_SoundCaptureBuffer::WriteToStream() 
//                TDx_SoundCaptureBuffer::WriteToStream() 
//                TDx_SoundCaptureBuffer::WriteToStream() 
//                TDx_SoundCaptureBuffer::Unlock() 
//                TDx_SoundCaptureBuffer::CloseStream() 
//              
//              Before calling this method, you must setup the 
//              TDx_SoundCaptureBuffer::StreamFormat property, 
//              and also the TDx_SoundCaptureBuffer::StreamSize property. 
//              
//              After this method returns, the 
//              TDx_SoundCaptureBuffer::StreamSize property contains the 
//              total number of bytes streamed. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              
//                TDX_BADPARAMS 
//                TDX_ERROR 
// Params:      pFileName - 
//                The FileName parameter defines the path and filename of the 
//                new .wav file which is to be created. 
//              pFormat - 
//                The Format method parameter describes the format of the sound 
//                file to be created. 
//                This parameter must point to a user-supplied WAVEFORMATEX 
//                structure that has been filled with appropriate values. 
//              pFormatSize - 
//                The FormatSize parameter must contain the size of the 
//                WAVEFORMATEX structure passed into this method via the Format 
//                parameter. 
//                Generally this will be sizeof(WAVEFORMATEX) but it may differ 
//                depending on the definition of the WAVEFORMATEX. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::SaveToFile( AnsiString pFileName, WAVEFORMATEX* pFormat, int pFormatSize )
{
// check params
if (pFileName=="")
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError(this, Name+"::CreateFromFile()", "TDX_BADPARMS", "The 'FileName' parameter cannot be a NULL string." );
    return false;
    }
if (pFileName.UpperCase().Pos(".WAV")==0) pFileName = pFileName +".WAV";

// check params
if (pFormat==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::SaveToFile()", "TDX_BADPARAMS", "The 'pFormat' parameter cannot be NULL" );
    return false;
    }
if (pFormatSize<sizeof(WAVEFORMATEX))
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::SaveToFile()", "TDX_BADPARAMS", "The 'pFormatSize' parameter must be at least sizeof(WAVEFORMATEX)." );
    return false;
    }

// remember the size of the stream, it's about to be replaced but it still needs to be used here
dword bytes_total = fStreamSize;

// assume we want to save the file no matter what
if (StreamIsOpen) CloseStream();

// open the wave file and set it up ready for writing data
bool success = CreateStream( pFileName, pFormat, pFormatSize );
if (!success)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::SaveToFile()", "TDX_ERROR", "The SaveToFile() method failed because "+Name+"::CreateSoundBuffer() failed." );
    CloseStream();
    return false;
    }

// write the entire sound buffer
void* first_block = NULL;
void* second_block = NULL;
dword first_block_length;
dword second_block_length;
dword dummy_bytes_written;

success = Lock( 0, bytes_total, &first_block, &first_block_length, &second_block, &second_block_length, 0 );
if (!success)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::SaveToFile()", "TDX_ERROR", "The SaveToFile() method failed because "+Name+"::Lock() failed." );

    CloseStream();
    return false;
    }

success = WriteToStream( bytes_total, (byte*) first_block, &dummy_bytes_written );
if (!success)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::SaveToFile()", "TDX_ERROR", "The SaveToFile() method failed because "+Name+"::WriteToStream() failed." );

    Unlock( first_block, bytes_total, NULL, 0 );
    CloseStream();
    return false;
    }

Unlock( first_block, bytes_total, NULL, 0 );
CloseStream();

fErrorValue = DS_OK;
return true;
}

// --------------------------------------------------------------------------
// Method:      Start()
// Description: The TDx_SoundCaptureBuffer::Start method will start 
//              retrieving sound data into this capture buffer. 
//              
//              This method will have no effect if the buffer is already 
//              capturing. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DSERR_INVALIDPARAM 
//              DSERR_NODRIVER 
//              DSERR_OUTOFMEMORY 
// Params:      pFlags - 
//                The Flags parameter defines a flag specifying capture buffer 
//                behavior when capturing sound data. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DSCBSTART_LOOPING -
//                    The capture buffer is looping. 
//                    The buffer returns to the beginning and continues 
//                    capturing when it reaches the end of the buffer. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::Start( dword pFlags )
{
// Original Function Definition
// HRESULT Start( 
//   DWORD dwFlags   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Start()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUNDCAPTUREBUFFER->Start( (DWORD) pFlags );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::Start()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      Stop()
// Description: The TDx_SoundCaptureBuffer::Stop method will halt the capture 
//              of data into this buffer. 
//              This method will have no effect if the buffer is already 
//              stopped. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DSERR_NODRIVER 
//              DSERR_OUTOFMEMORY 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::Stop()
{
// Original Function Definition
// HRESULT Stop(); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Stop()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUNDCAPTUREBUFFER->Stop(  );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::Stop()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      Unlock()
// Description: The TDx_SoundCaptureBuffer::Unlock method will unlock a 
//              capture buffer previously locked with 
//              TDx_SoundCaptureBuffer::Lock(). 
//              
//              Both pointers and both byte values returned by 
//              TDx_SoundCaptureBuffer::Lock() must be supplied, even if 0 
//              bytes were locked with the second pointer. 
//              
//              The capture buffer should not be locked for long periods as 
//              the capture cursor may reach the locked bytes and possibly 
//              cause configuration dependent audio problems. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DSERR_INVALIDPARAM 
//              DSERR_INVALIDCALL 
// Params:      pAudioPtr1 - 
//                The AudioPtr1 parameter should reference the value returned 
//                in the AudioPtr1 parameter of TDx_SoundCaptureBuffer::Lock(). 
//              pAudioBytes1 - 
//                The AudioBytes1 parameter defines the number of bytes read 
//                from the area referenced by the AudioPtr1 parameter. 
//              pAudioPtr2 - 
//                The AudioPtr2 parameter should reference the value returned 
//                in the AudioPtr2 parameter of TDx_SoundCaptureBuffer::Lock(). 
//              pAudioBytes2 - 
//                The AudioBytes2 parameter defines the number of bytes read 
//                from the area referenced by the AudioPtr2 parameter. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::Unlock( void* pAudioPtr1, dword pAudioBytes1, void* pAudioPtr2, dword pAudioBytes2 )
{
// Original Function Definition
// HRESULT Unlock( 
//   LPVOID lpvAudioPtr1, 
//   DWORD dwAudioBytes1, 
//   LPVOID lpvAudioPtr2, 
//   DWORD dwAudioBytes2   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Unlock()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pAudioPtr1==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Unlock()", "TDX_BADPARAMS", "'pAudioPtr1' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTSOUNDCAPTUREBUFFER->Unlock( (LPVOID) pAudioPtr1, (DWORD) pAudioBytes1, (LPVOID) pAudioPtr2, (DWORD) pAudioBytes2 );

// Handle any Known Results
if (fErrorValue!=DS_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::Unlock()", TDx_Sound_Library_ErrorString(fErrorValue), TDx_Sound_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      WriteToStream()
// Description: The WriteToStream method will write a specified amount of 
//              sound data to the current .wav file. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              TDX_BADPARAMS 
//              TDX_ERROR 
// Params:      pBytesToWrite - 
//                The BytesToWrite parameter defines the amount, in bytes, of 
//                sound data to write to the current .wav file. 
//              pSoundData - 
//                The SoundData parameter references the array of bytes that 
//                will be written to the current .wav file. 
//                
//                This parameter may be set to one of the pointers returned by 
//                TDx_SoundCaptureBuffer::Lock() to write sound data directly 
//                from the capture buffer. 
//              pBytesActuallyWritten - 
//                The BytesActuallyWritten parameter will reference the amount, 
//                in bytes, that was actually written to the file if this 
//                method returns successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_SoundCaptureBuffer::WriteToStream( dword pBytesToWrite, byte* pSoundData, dword* pBytesActuallyWritten )
{
if (pBytesToWrite==0)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError(this, Name+"::WriteToStream()", "TDX_BADPARAMS", "Cannot write from the stream because the 'BytesToWrite' parameter is 0." );
    return false;
    }
if (pSoundData==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError(this, Name+"::WriteToStream()", "TDX_BADPARAMS", "Cannot write from the stream because the 'SoundData' parameter is NULL." );
    return false;
    }
if (pBytesActuallyWritten==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError(this, Name+"::WriteToStream()", "TDX_BADPARAMS", "Cannot write from the stream because the 'BytesActuallyWrite' parameter is NULL." );
    return false;
    }

if (!StreamIsOpen)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, Name+"::WriteToStream()", "TDX_ERROR", "Cannot write from the stream because it is not open." );
    return false;
    }

// write the relevant number of bytes to the file
int bytes_actually_written = write( fStreamHandle, (void*) pSoundData, pBytesToWrite );
if (bytes_actually_written==-1)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, Name+"::WriteToStream()", "TDX_ERROR", "Cannot write because the write() function reached the end of file before writing enough data." );
    return false;
    }

// done
*pBytesActuallyWritten = bytes_actually_written;
fStreamSize += bytes_actually_written;
fErrorValue = DS_OK;
return true;
}

// --------------------------------------------------------------------------
// Internal Interface Access
// --------------------------------------------------------------------------
LPDIRECTSOUNDCAPTUREBUFFER __fastcall TDx_SoundCaptureBuffer::FGetInternal_LPDIRECTSOUNDCAPTUREBUFFER()
{
return fLPDIRECTSOUNDCAPTUREBUFFER;
}
// --------------------------------------------------------------------------
LPDIRECTSOUNDCAPTUREBUFFER* __fastcall TDx_SoundCaptureBuffer::FGetInternal_LPDIRECTSOUNDCAPTUREBUFFER_Ptr()
{
return &fLPDIRECTSOUNDCAPTUREBUFFER;
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundCaptureBuffer::FSetInternal_LPDIRECTSOUNDCAPTUREBUFFER( LPDIRECTSOUNDCAPTUREBUFFER pLPDIRECTSOUNDCAPTUREBUFFER )
{
if (!fCreated)
    {
    fLPDIRECTSOUNDCAPTUREBUFFER = pLPDIRECTSOUNDCAPTUREBUFFER;
    fCreated = (fLPDIRECTSOUNDCAPTUREBUFFER!=NULL);
    }
}
// --------------------------------------------------------------------------
void __fastcall TDx_SoundCaptureBuffer::Internal_LPDIRECTSOUNDCAPTUREBUFFER_Update()
{
fCreated = (fLPDIRECTSOUNDCAPTUREBUFFER!=NULL);
}

// --------------------------------------------------------------------------
