
// ==========================================================================
// File:        TDx_Sound_Library_Functions.CPP
// Description: This file implements standard functions used with the 
//              TDx_Sound_Library components.
//
// "TDx_Sound_Library"
// (c) 2002, BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

#include <vcl\vcl.h>
#pragma hdrstop

// --------------------------------------------------------------------------
#include "TDx_Library_Defns.H"
#include "TDx_Library_Functions.H"
// --------------------------------------------------------------------------
#include "TDx_Sound_Library_Defns.H"
#include "TDx_Sound_Library_Functions.H"

// --------------------------------------------------------------------------
// Func:            TDx_Sound_Library_ErrorString()
// Description:     Use this function to return the name of the error.
// --------------------------------------------------------------------------
AnsiString __fastcall TDx_Sound_Library_ErrorString(int Error)
{
AnsiString str = TDx_Library_ErrorString(Error);
if (str!="") return str;
switch (Error)
    {
    case DS_OK:	str = "DS_OK"; break;
    case DSERR_ALLOCATED: str = "DSERR_ALLOCATED"; break;
    case DSERR_ALREADYINITIALIZED: str = "DSERR_ALREADYINITIALIZED"; break;
    case DSERR_BADFORMAT: str = "DSERR_BADFORMAT"; break;
    case DSERR_BUFFERLOST: str = "DSERR_BUFFERLOST"; break;
    case DSERR_CONTROLUNAVAIL: str = "DSERR_CONTROLUNAVAIL"; break;
    case DSERR_GENERIC: str = "DSERR_GENERIC"; break;
    case DSERR_INVALIDCALL: str = "DSERR_INVALIDCALL"; break;
    case DSERR_INVALIDPARAM: str = "DSERR_INVALIDPARAM"; break;
    case DSERR_NOAGGREGATION: str = "DSERR_NOAGGREGATION"; break;
    case DSERR_NODRIVER: str = "DSERR_NODRIVER"; break;
    case DSERR_NOINTERFACE: str = "DSERR_NOINTERFACE"; break;
    case DSERR_OTHERAPPHASPRIO: str = "DSERR_OTHERAPPHASPRIO"; break;
    case DSERR_OUTOFMEMORY: str = "DSERR_OUTOFMEMORY"; break;
    case DSERR_PRIOLEVELNEEDED: str = "DSERR_PRIOLEVELNEEDED"; break;
    case DSERR_UNINITIALIZED: str = "DSERR_UNINITIALIZED"; break;
    case DSERR_UNSUPPORTED: str = "DSERR_UNSUPPORTED"; break;
    default: str = "UNKNOWN ERROR ["+IntToStr(Error)+"]"; break;
    }
return str;
}
//-----------------------------------------------------------------------------------------
// Func:            TDx_Sound_Libray_ErrorMessage()
// Description:     Use this function to return information about the error.
//-----------------------------------------------------------------------------------------
AnsiString __fastcall TDx_Sound_Library_ErrorMessage(int Error)
{
AnsiString str = TDx_Library_ErrorMessage(Error);
if (str!="") return str;
switch (Error)
    {
    case DS_OK:	str = "The request completed successfully"; break;
    case DSERR_ALLOCATED: str = "The request failed because resources, such as a priority level, were already in use by another caller."; break;
    case DSERR_ALREADYINITIALIZED: str = "The object is already initialized."; break;
    case DSERR_BADFORMAT: str = "The specified wave format is not supported."; break;
    case DSERR_BUFFERLOST: str = "The buffer memory has been lost and must be restored."; break;
    case DSERR_CONTROLUNAVAIL: str = "The control (volume, pan, and so forth) requested by the caller is not available."; break;
    case DSERR_GENERIC: str = "An undetermined error occurred inside the DirectSound subsystem."; break;
    case DSERR_INVALIDCALL: str = "This function is not valid for the current state of this object."; break;
    case DSERR_INVALIDPARAM: str = "An invalid parameter was passed to the returning function."; break;
    case DSERR_NOAGGREGATION: str = "The object does not support aggregation."; break;
    case DSERR_NODRIVER: str = "No sound driver is available for use."; break;
    case DSERR_NOINTERFACE: str = "The requested COM interface is not available."; break;
    case DSERR_OTHERAPPHASPRIO: str = "Another application has a higher priority level, preventing this call from succeeding."; break;
    case DSERR_OUTOFMEMORY: str = "The DirectSound subsystem could not allocate sufficient memory to complete the caller's request."; break;
    case DSERR_PRIOLEVELNEEDED: str = "The caller does not have the priority level required for the function to succeed."; break;
    case DSERR_UNINITIALIZED: str = "The IDirectSound::Initialize method has not been called or has not been called successfully before other methods were called."; break;
    case DSERR_UNSUPPORTED: str = "The function called is not supported at this time."; break;
    default: str = "UNKNOWN ERROR ["+IntToStr(Error)+"]"; break;
    }
return str;
}
//-----------------------------------------------------------------------------------------
